﻿'From etoys2.2 of 27 September 2007 [latest update: #1796] on 8 December 2007 at 12:17:28 am'!
"Change Set:		sokoban
Date:			8 December 2007
Author:			Robert Krahn

Authors: Alan Bränzel, Felix Elliger, Ralf Gehrer, Michael Grünewald, Alexander Kuscher, Christina Schwendy, and Marcel Taeumel

Hasso-Plattner-Institut
Software Architecture Group

http://www.hpi.uni-potsdam.de/swa/"!

ImageMorph subclass: #SokoAnimatedMorph
	instanceVariableNames: 'animations playfield stepTime currentAnimation direction wait waitTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoAnimatedMorph commentStamp: 'afk 6/11/2007 21:53' prior: 0!
I'm responsible for the animation of the actors in the game. 
This includes methods for adding, starting and stopping animations.
!

SokoAnimatedMorph subclass: #SokoActor
	instanceVariableNames: 'location isMoving offset steps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoActor commentStamp: 'Tisch 6/12/2007 22:39' prior: 0!
I am the superclass of all moveable objects in play.
You can create new instances of my subclasses SokoBox and SokoPlayer and then make them move arround.!

Object subclass: #SokoAnimation
	instanceVariableNames: 'frames pictureIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoAnimation commentStamp: 'afk 6/11/2007 21:57' prior: 0!
I represent an animation. You can access me via a dictionary that is an instance variable of AnimatedSokoMorph. 
I have the abillitiy to permanantly return the images that are stored in the field frames (a Collection).
The field pictureIndex helps to ensure that all pictures are returned in the right ordner.!

SokoActor subclass: #SokoBox
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoBox commentStamp: 'mig 6/13/2007 14:51' prior: 0!
I represent a box in the play, that could be pushed by a player.!

Object subclass: #SokoCommand
	instanceVariableNames: 'direction actors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoCommand commentStamp: 'mt 5/30/2007 17:45' prior: 0!
Encapsulates a command for some playfield objects (e.g. player or boxes).!

SokoAnimatedMorph subclass: #SokoField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoField commentStamp: 'Tisch 6/12/2007 22:42' prior: 0!
I am the superclass of all ground elements of the playfield.!

ImageMorph subclass: #SokoGame
	instanceVariableNames: 'playfield commandStack level actions levelSet levelNumber blockInputs prototypes levelSetNumber'
	classVariableNames: 'ImageStorage'
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoGame commentStamp: 'mig 7/20/2007 20:18' prior: 0!
I'm just another implementation of the game "Sokoban" with cool features and nice graphics.

I represent a status bar with some control buttons and two counters for moves and pushes. 
A playfield is my submorph and contains walls, boxes, players, ...

If you want to change the movement/undo keys just add them in "SokoGame>>#associateKeysToActions".

Just use the object tool for starting a new game or type "SokoGame new initializeToStandAlone openInWorld" into a workspace and "do it".
!

Object subclass: #SokoLevel
	instanceVariableNames: 'fields mapsize boxes players replay'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoLevel commentStamp: 'mig 7/18/2007 13:56' prior: 0!
I represent a parsed level. 
Use fromClassicFormat: or fromSWAFormat: to get an instance.!

SokoActor subclass: #SokoPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoPlayer commentStamp: 'Tisch 6/12/2007 22:43' prior: 0!
I represent a player in play. The user can make me move a arround.!

Morph subclass: #SokoPlayfield
	instanceVariableNames: 'players boxes fields game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoPlayfield commentStamp: 'mt 6/12/2007 21:05' prior: 0!
I'm the visible playfield of the Sokoban game.
Enter my area with the mouse cursor to enable key input for player moving.!

SokoField subclass: #SokoWall
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoWall commentStamp: 'Tisch 6/12/2007 23:40' prior: 0!
I represent a wall in the play.
No kind of SokoActor is allowed to stand on me.!

SokoField subclass: #SokoWay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoWay commentStamp: 'Tisch 6/12/2007 23:41' prior: 0!
I represent a way in the play.
SokoActor objects are allowed to stand on me.!

SokoWay subclass: #SokoOneWay
	instanceVariableNames: 'restrictedDirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoOneWay commentStamp: 'fe 7/10/2007 23:01' prior: 0!
I am a field, that has one side from where a box cannot enter me. Concerning the possibilities of the player I am just a normal way.
Boxes and players can leave me in every direction they want to.!

SokoWay subclass: #SokoTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoTarget commentStamp: 'Tisch 6/12/2007 23:38' prior: 0!
I represent a target field in the playfield. 
If all target fields in the current map are filled with boxes the user wins.!

Object subclass: #Stack
	instanceVariableNames: 'linkedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Stack'!

!Stack commentStamp: 'dc 7/24/2005 15:41' prior: 0!
I implement a simple Stack. #push: adds a new object of any kind on top of the stack. #pop returns the first element and remove it from the stack. #top answer the first element of the stack without removing it.!

Stack subclass: #SokoCommandStack
	instanceVariableNames: 'pushes moves redoStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA-Sokoban'!

!SokoCommandStack commentStamp: 'mig 7/20/2007 20:17' prior: 0!
I am responsible for holding done und undone commands!

Link subclass: #StackLink
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Stack'!

!StackLink commentStamp: '<historical>' prior: 0!
I implement an element of a stack. I'm a container for any type of object, saved into the 'element' variable. My superclass Link allows me to be part of a LinkedList.!


!SokoAnimatedMorph methodsFor: 'drawing' stamp: 'rkrk 11/17/2007 21:44'!
addAnimationOf: aKind to: aDirection for: aSokoObjectName
	"adds animations by finding animation-specific pictures and loading them from the filesystem"

	| aDirectoryObject aFilenameCollection anAnimation |
	
	aDirectoryObject := nil. "FileDirectory new setPathName: ((SokoGame resourcePath) asString). "
	
	"store all proper filenames into a collection"
	aFilenameCollection := self findAllFileNamesOf: aKind to: aDirection for: aSokoObjectName 
	in:aDirectoryObject.

	"if there is at least one proper file load it and put it into an animation"
	aFilenameCollection ifNotEmpty: [ 
			anAnimation := self loadFilesFrom:aDirectoryObject By:aFilenameCollection.
          (self animations at:aKind ifAbsentPut:(Dictionary new)) at:aDirection put:anAnimation. 
      ]  ! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'afk 7/20/2007 10:51'!
animations
	^animations! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'afk 7/20/2007 10:52'!
animations:anAnimation
	^animations := anAnimation
	! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'mt 11/29/2007 22:41'!
animationWait: aNumber
	"Sets the waiting time between frames."

	waitTime := aNumber! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'afk 7/20/2007 10:58'!
currentAnimation
	^currentAnimation ! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'afk 7/20/2007 10:58'!
currentAnimation:anAnimation
	^currentAnimation := anAnimation! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'mt 11/29/2007 22:09'!
direction
	^direction! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'mt 11/29/2007 22:09'!
direction: aSymbol
	direction := aSymbol! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'mt 5/30/2007 16:01'!
playfield
	^playfield! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'mt 5/30/2007 16:01'!
playfield: aSokoPlayfield
	^playfield := aSokoPlayfield! !

!SokoAnimatedMorph methodsFor: 'accessing' stamp: 'mt 11/29/2007 22:33'!
step
	"Responsible for the distinction between one-picture-animations (fixed-image)
	and animations with more than one picture. Defines what to do in each case."
	
	| current next|

	wait = 0
		ifTrue: [
			wait := waitTime.

	"do nothing if there is no current animation"
	self currentAnimation ifNil: [^nil].
	
	"if the pictureindex is not changing do not change the image of the morph"
	current := self currentAnimation pictureIndex.
	self currentAnimation nextFrame.
	next := self currentAnimation pictureIndex.

	current = next
		ifFalse: [
			self changeImage.
	].



		]
	ifFalse: [wait := wait - 1].

! !

!SokoAnimatedMorph methodsFor: 'animation' stamp: 'mt 11/29/2007 22:16'!
changeImage
	"set the image to the current Frame in the current Animation"

	| x y |
	"x and y needed to center the new image."
	x := self x.
	y := self y.
	
	self setNewImageFrom: (self currentAnimation currentFrame).
	
	self x: x.
	self y: y.! !

!SokoAnimatedMorph methodsFor: 'animation' stamp: 'mt 11/29/2007 23:03'!
startAnimation: aKind to: aDirection
	"loads animations from the animations-dictionary and starts them"

	"if there is no match for the given animation or kind change nothing"

	self animations at:aKind ifAbsent:
		[^nil].
	(self animations at:aKind) at:aDirection ifAbsent:
		[^nil].

	self direction: aDirection.
	self currentAnimation:((self animations at:aKind) at:aDirection).
	self currentAnimation resetPictureIndex.
	self changeImage.! !

!SokoAnimatedMorph methodsFor: 'animation' stamp: 'mt 11/29/2007 22:16'!
stepTime
	"stepTime is mainly used to control the speed of the animations"

	^stepTime! !

!SokoAnimatedMorph methodsFor: 'animation' stamp: 'mt 11/29/2007 22:16'!
stepTime: aNumber
	"Setting the stepTime to another number (milliseconds) to change the
	speed of an animation"

	stepTime := aNumber.! !

!SokoAnimatedMorph methodsFor: 'geometry' stamp: 'afk 7/20/2007 10:59'!
currentFrameSize
	"returns the size of the current image"
	
	^self currentAnimation currentFrame width @ self currentAnimation currentFrame height.! !

!SokoAnimatedMorph methodsFor: 'private' stamp: 'mig 11/13/2007 19:12'!
findAllFileNamesOf: aKind to: aDirection for: aSokoObjectName in:aDirectoryObject
	"fetching all proper filenames"

	| aFilenameCollection |
	
	aFilenameCollection  := SokoGame matchingGraphics: (aSokoObjectName asString),'_',(aKind asString),'_',(aDirection asString),'*'.
	^aFilenameCollection.! !

!SokoAnimatedMorph methodsFor: 'private' stamp: 'mig 11/13/2007 18:19'!
loadFilesFrom:aDirectoryObject By:aFilenameCollection
	"loads all files matching the names in the given collection in the given directory and 
	returns an animation object with all pictures in it"

	| anAnimation |
	anAnimation := SokoAnimation new.
	
	aFilenameCollection do: [ :picture | anAnimation frames add: (SokoGame loadGraphicWithName: picture)].
	^anAnimation
	
! !

!SokoAnimatedMorph methodsFor: 'initialization' stamp: 'mt 11/30/2007 15:03'!
initialize
	"Initializing the SokoAnimatedMorph. Therefore it is making a new
	Dictionary for the animations and setting the stepTime to it's 
	standard."

	super initialize.
	self 
		animations:(Dictionary new);
		stepTime:200.
	
	waitTime := SokoGame animationWaitTime.
	wait := waitTime.! !

!SokoAnimatedMorph methodsFor: 'copying' stamp: 'afk 7/20/2007 11:02'!
postCopy
	"copying all animations that are in the animations-dictionary"
	
	super postCopy.
	self animations: (self animations collect: [:animation | animation copy]).
	^self.
! !


!SokoActor methodsFor: 'moving' stamp: 'mig 7/20/2007 20:14'!
isPlayerIn: aDirection
	"Prooves if there is a player in front of the actor"
	
	(self playfield playerAt: (self location + (SokoGame offsetFrom: aDirection)))
		ifNil: [^false].
	 
	^true.! !

!SokoActor methodsFor: 'moving' stamp: 'fe 7/20/2007 12:09'!
isValidFieldIn: aDirection for: aSokoActor
	"Check for a valid field in the given direction"	

	((self playfield fieldAt: ((SokoGame offsetFrom: aDirection) + self location))
		isMoveAllowedFrom: (SokoGame oppositeDirectionOf: aDirection) by: aSokoActor)
			ifFalse: [
				"look into direction"
				self startAnimation: #standing to: aDirection.
				^false].
	
	^true.! !

!SokoActor methodsFor: 'moving' stamp: 'mt 11/30/2007 15:03'!
step
	"This frequently called function controls the movement. Super step is used for animation."
	
	super step.

	self isMoving
		ifTrue: [
			self steps = 0
				ifFalse: [
					self steps: self steps - SokoGame stepRange.
					self position: self position + (SokoGame stepRange * offset).
				].
		].

	! !

!SokoActor methodsFor: 'accessing' stamp: 'mt 11/29/2007 21:02'!
isMoving
	^isMoving! !

!SokoActor methodsFor: 'accessing' stamp: 'mt 11/29/2007 21:02'!
isMoving: aBoolean
	isMoving := aBoolean.! !

!SokoActor methodsFor: 'accessing' stamp: 'mig 6/13/2007 15:47'!
location
	^location! !

!SokoActor methodsFor: 'accessing' stamp: 'mig 6/13/2007 15:47'!
location: aPoint
	location := aPoint! !

!SokoActor methodsFor: 'accessing' stamp: 'fe 6/23/2007 14:21'!
moveTo: aDirection animatedWith: anAnimationType withUndo: aBoolean
	
	"This method makes the Morph move into a direction by using a special animation"
	"In the end it gives a signal to the SokoLogic, that the animation has finished."
	
	^self subclassResponsibility.! !

!SokoActor methodsFor: 'accessing' stamp: 'mt 11/29/2007 21:29'!
offset
	^offset! !

!SokoActor methodsFor: 'accessing' stamp: 'mt 11/29/2007 21:29'!
offset: aPoint
	offset := aPoint.! !

!SokoActor methodsFor: 'accessing' stamp: 'mt 11/29/2007 21:25'!
steps
	^steps! !

!SokoActor methodsFor: 'accessing' stamp: 'mt 11/29/2007 21:25'!
steps: aNumber
	steps := aNumber.! !

!SokoActor methodsFor: 'initialization' stamp: 'mt 11/29/2007 23:08'!
initialize
	super initialize.
	self isMoving: false.
	self offset: (0@0).
	self steps: 0.
	self stepTime: 1.! !


!SokoAnimatedMorph class methodsFor: 'new-morph participation' stamp: 'mt 6/14/2007 17:59'!
includeInNewMorphMenu
	^false.! !


!SokoAnimation methodsFor: 'accessing' stamp: 'mig 7/20/2007 20:13'!
currentFrame
	"Returns the picture at the current pictureIndex"
	
	^self frames at: self pictureIndex.! !

!SokoAnimation methodsFor: 'accessing' stamp: 'afk 6/1/2007 23:58'!
frames
	"return the instance variable frames that is an OrderedCollection Object"
	
	^frames! !

!SokoAnimation methodsFor: 'accessing' stamp: 'afk 7/20/2007 11:10'!
frames:aFrame
	^frames := aFrame! !

!SokoAnimation methodsFor: 'accessing' stamp: 'mig 7/20/2007 20:12'!
nextFrame
	"this method is returning an image depending on the value of pictureIndex. 
	It starts from the beginning if it iterated over all images in the framecollection"
	
	self pictureIndex:(self pictureIndex \\ (self frames size) + 1).
	^self currentFrame.! !

!SokoAnimation methodsFor: 'accessing' stamp: 'afk 7/17/2007 18:52'!
pictureIndex
	"Returns the pictureIndex that is a number"
	
	^pictureIndex! !

!SokoAnimation methodsFor: 'accessing' stamp: 'afk 7/20/2007 11:10'!
pictureIndex:aNumber
	^pictureIndex := aNumber! !

!SokoAnimation methodsFor: 'initialization' stamp: 'afk 7/20/2007 11:11'!
initialize
	"set standard variables for the instance fields"
	
	super initialize.
	self frames:OrderedCollection new.
	self pictureIndex:1.! !

!SokoAnimation methodsFor: 'private' stamp: 'mig 7/20/2007 20:16'!
resetPictureIndex
	"resets the current picture index"
	
	self pictureIndex: 1.! !


!SokoBox methodsFor: 'initialization' stamp: 'mt 11/29/2007 22:42'!
initialize

	super initialize.
	
	#(#standing #glowing) do: [:aKind |
		#(#up) do: [:aDirection |
			self addAnimationOf: aKind to: aDirection for: #box.
		]
	].
	
	self
		animationWait: 20; 
		startAnimation: #standing to: #up.
! !

!SokoBox methodsFor: 'testing' stamp: 'mig 6/13/2007 19:01'!
isOnTarget

	"Answers a Boolean whether the Box is on a target field."
		
	^(playfield fieldAt: (self location)) isTargetField.
	! !

!SokoBox methodsFor: 'accessing' stamp: 'mt 6/27/2007 15:51'!
location: aPoint
	super location: aPoint.

	self isOnTarget
		ifTrue: [self startAnimation: #glowing to: #up]
		ifFalse: [self startAnimation: #standing to: #up].! !

!SokoBox methodsFor: 'moving' stamp: 'mt 11/29/2007 23:21'!
moveTo: aDirection animatedWith: anAnimationType withUndo: aBoolean
	
"start animating the player - this does not mean that he really moves forward"
	
	aBoolean
		ifTrue: [self startAnimation: anAnimationType to: aDirection]
		ifFalse: [self startAnimation: #standing to: aDirection].
	
	self steps: (
		(aDirection = #left) | (aDirection = #right)
			ifTrue: [ SokoField tileWidth ]
			ifFalse: [ SokoField tileHeight ]
	).
	
	"memorize next location"
	self offset: (SokoGame offsetFrom: aDirection).

	self isMoving: true.

	"stopAnimation."
! !

!SokoBox methodsFor: 'moving' stamp: 'mt 11/30/2007 14:58'!
step
	self isMoving
		ifTrue: [
			self steps = 0
				ifTrue: [
					self isMoving: false.
					self location: self location + offset.

					"Is the box on a target field?"
						self isOnTarget
							ifTrue: [self startAnimation: #glowing to: #up]
							ifFalse: [self startAnimation: #standing to: #up].
					
				]
		].
	super step.! !


!SokoCommand methodsFor: 'private' stamp: 'mt 7/4/2007 07:49'!
actors
	^actors.! !

!SokoCommand methodsFor: 'private' stamp: 'mt 7/4/2007 07:49'!
direction
	^direction.! !

!SokoCommand methodsFor: 'private' stamp: 'mt 7/4/2007 07:50'!
direction: aSymbol
	direction := aSymbol.! !

!SokoCommand methodsFor: 'initialize' stamp: 'mt 7/4/2007 07:48'!
actors: aSokoActorCollection
	"This should only be used for initialization."
	actors := aSokoActorCollection! !

!SokoCommand methodsFor: 'processing' stamp: 'mig 7/18/2007 14:01'!
execute
	"do the current command"
	self executeMovingBackwards: false.! !

!SokoCommand methodsFor: 'processing' stamp: 'mt 11/29/2007 22:27'!
executeMovingBackwards: aBoolean
	"begin player and box moving"
	| animationType |
	
	aBoolean
		ifTrue: [self direction: (SokoGame oppositeDirectionOf: self direction)].
		
	animationType :=
		self isPushCommand
			ifTrue: [#pushing]
			ifFalse: [#walking].

	self actors first moveTo: self direction animatedWith: animationType withUndo: aBoolean.

	self actors size > 1
		ifTrue: [
			self actors last moveTo: self direction animatedWith: animationType withUndo: aBoolean
		].! !

!SokoCommand methodsFor: 'processing' stamp: 'mig 7/18/2007 14:01'!
undo
	"undo the current command"
	self executeMovingBackwards: true.! !

!SokoCommand methodsFor: 'testing' stamp: 'mig 7/19/2007 23:16'!
isPushCommand
	"Checks whether a player pushes a box or moves alone."
	^(self actors size > 1).! !


!SokoCommand class methodsFor: 'instance creation' stamp: 'mig 7/19/2007 23:47'!
createFor: someSokoActors movingTo: aDirection
	"All SokoActor instances in the collection are intended to move into the given direction."
	
	^((self new)
		direction: aDirection;
		actors: someSokoActors;
		yourself
	)! !


!SokoField methodsFor: 'directing' stamp: 'Tisch 6/10/2007 13:03'!
isMoveAllowedFrom: aDirection by: aSokobanObject

	"This method answers a Boolean whether the Object can move from the field into the given direction"

	self subclassResponsibility
! !

!SokoField methodsFor: 'testing' stamp: 'mt 6/11/2007 16:35'!
isTargetField
	^false.! !

!SokoField methodsFor: 'testing' stamp: 'mt 6/13/2007 22:07'!
isWayField
	^false.! !


!SokoField class methodsFor: 'constants' stamp: 'mt 6/1/2007 16:13'!
tileHeight
	^ 30.! !

!SokoField class methodsFor: 'constants' stamp: 'mt 6/1/2007 16:13'!
tileWidth
	^ 50.! !


!SokoGame methodsFor: 'accessing' stamp: 'mig 7/20/2007 19:52'!
actions
	^ actions! !

!SokoGame methodsFor: 'accessing' stamp: 'mt 7/17/2007 17:56'!
cloneFrom: anArray
	"Retrieves a clone from an object if there is a prototype present - otherwise one will be created"
		
	(self prototypes includesKey: anArray) ifFalse: [
		| prototype |
		prototype := anArray first new.
		anArray allButFirstDo: [ :parameter |
			prototype initializeWith: parameter.
		].
		self prototypes at: anArray put: prototype.
	].

	^(self prototypes at: anArray) copy.
! !

!SokoGame methodsFor: 'accessing' stamp: 'mig 7/20/2007 19:55'!
levelNumber
	^ levelNumber! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 19:52'!
actions: anObject
	^ actions := anObject! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 20:01'!
blockInputs
	^ blockInputs! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 20:01'!
blockInputs: anObject
	^ blockInputs := anObject! !

!SokoGame methodsFor: 'private' stamp: 'mt 7/17/2007 12:14'!
commandStack
	^commandStack.! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 19:59'!
commandStack: aCommandStack
	commandStack := aCommandStack! !

!SokoGame methodsFor: 'private' stamp: 'mt 7/12/2007 13:45'!
level
	^level.! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 19:56'!
levelNumber: aNumber
	levelNumber := aNumber! !

!SokoGame methodsFor: 'private' stamp: 'mt 7/17/2007 12:14'!
levelSet
	^levelSet.! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 19:53'!
levelSet: anObject
	levelSet := anObject.! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 19:51'!
level: anObject
	level := anObject! !

!SokoGame methodsFor: 'private' stamp: 'mt 7/12/2007 13:50'!
playfield
	^playfield.! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 19:49'!
playfield: anObject
	playfield := anObject! !

!SokoGame methodsFor: 'private' stamp: 'mt 7/2/2007 19:40'!
prototypes
	"Returns the dictionary with prototype objects for private usage."
	^prototypes! !

!SokoGame methodsFor: 'private' stamp: 'mig 7/20/2007 20:02'!
prototypes: anObject
	prototypes := anObject! !

!SokoGame methodsFor: 'initialization' stamp: 'mt 11/30/2007 09:00'!
associateKeysToActions
	"Associate a specific key to a valid action."
	
	self actions: Dictionary new.
	self actions
		add: $a                   -> [self handleMoveActionTo: #left for: self playfield playerOne];
		add: $d                   -> [self handleMoveActionTo: #right for: self playfield playerOne];
		add: $w                   -> [self handleMoveActionTo: #up for: self playfield playerOne];
		add: $s                   -> [self handleMoveActionTo: #down for: self playfield playerOne];
		add: Character arrowLeft  -> [self handleMoveActionTo: #left for: self playfield playerTwo];
		add: Character arrowRight -> [self handleMoveActionTo: #right for: self playfield playerTwo];
		add: Character arrowUp    -> [self handleMoveActionTo: #up for: self playfield playerTwo];
		add: Character arrowDown  -> [self handleMoveActionTo: #down for: self playfield playerTwo];
		add: Character backspace  -> [self handleUndoLastAction];
		add: Character space      -> [self handleLevelRestart];
		add: Character home       -> [self handleRedoLastUndo];
		add: Character pageUp     -> [self handleLevelSkip: -1];
		add: Character pageDown   -> [self handleLevelSkip: 1];
		add: $o                   -> ["self handleCustomLevel" self handleCycleLevelSets].! !

!SokoGame methodsFor: 'initialization' stamp: 'amb 7/20/2007 15:55'!
initializeButtons
	"create buttons of playfield and set appearance, position and keymapping of each button"
	
	"initialize level control buttons"
	self
		initializeButtonWithImage: 'open.png' withKey: $o atPosition: 10@200;
		initializeButtonWithImage: 'previous.png' withKey: Character pageUp atPosition: 80@200;
		initializeButtonWithImage: 'undo.png' withKey: Character backspace atPosition: 150@200;
		initializeButtonWithImage: 'restart.png'  withKey: Character space atPosition: 240@200;
		initializeButtonWithImage: 'redo.png' withKey: Character home atPosition: 290@200;
		initializeButtonWithImage: 'next.png' withKey: Character pageDown atPosition: 360@200.

	"initialize player control buttons"
	self
		initializeButtonWithImage: 'up.png' withKey: $w atPosition: 155@90;
		initializeButtonWithImage: 'down.png' withKey: $s atPosition: 155@135;
		initializeButtonWithImage: 'left.png' withKey: $a atPosition: 110@130;
		initializeButtonWithImage: 'right.png' withKey: $d atPosition: 205@130.
		
	"initialize player2 control buttons"
	self
		initializeButtonWithImage: 'up2.png' withKey: Character arrowUp atPosition: 460@90;
		initializeButtonWithImage: 'down2.png' withKey: Character arrowDown atPosition: 460@135;
		initializeButtonWithImage: 'left2.png' withKey: Character arrowLeft atPosition: 415@130;
		initializeButtonWithImage: 'right2.png' withKey: Character arrowRight atPosition: 510@130.
! !

!SokoGame methodsFor: 'initialization' stamp: 'mig 11/13/2007 18:15'!
initializeButtonWithImage: aFilename withKey: aKey atPosition: aPosition
	"creates a button and sets position and keymapping. The button image is loaded from the given filename."
	(self createButton)
		labelGraphic: (self class loadGraphicWithName: aFilename);
		arguments: aKey asOrderedCollection;
		position: aPosition + self position.! !

!SokoGame methodsFor: 'initialization' stamp: 'mt 11/30/2007 08:55'!
initializeFirstLevel
	"Selects a standard level set and runs the first level of this set."
	
	self
		initializeLevelSet;
		parseSokoLevelFrom: (self levelSet at: self levelNumber);
		createPlayfield.! !

!SokoGame methodsFor: 'initialization' stamp: 'mt 11/30/2007 08:57'!
initializeLevelSet
	"Selects a standard level set and runs the first level of this set."
	
	levelSetNumber = 1 ifTrue: [self levelSet: (self class levelSetWith: 'swaset' with: 5)].
	levelSetNumber = 2 ifTrue: [self levelSet: (self class levelSetWith: 'microban' with: 153)].
	levelSetNumber = 3 ifTrue: [self levelSet: (self class levelSetWith: 'masmicroban' with: 129)].
	levelSetNumber = 4 ifTrue: [
		self levelSet: (
			(self class levelSetWith: 'swaset' with: 5),
			(self class levelSetWith: 'microban' with: 153),
			(self class levelSetWith: 'masmicroban' with: 129)
		)].
	
	self levelSet: self levelSet shuffled.
	self levelNumber: 1.! !

!SokoGame methodsFor: 'initialization' stamp: 'mig 7/20/2007 19:58'!
initializeNextLevel: aDelay
	"Initializes the next level after waiting some seconds (aDelay) so that the player is able to realize the process (e.g. watching a sokoactor's winning animation)."
	
	[
		(Delay forSeconds: aDelay) wait.
		
		self commandStack clear.
		self playfield delete.
				
		self levelNumber > self levelSet size
			ifFalse: [	
				self
					parseSokoLevelFrom: (self levelSet at: self levelNumber);
					createPlayfield;
					finishInputProcessing
			]
			ifTrue: [
				self handleGameDone
			]
	] fork.! !

!SokoGame methodsFor: 'initialization' stamp: 'mig 7/20/2007 20:00'!
initializeStatusline
	"set up two self updating strings for showing moves and pushes"
	
	|text|
	
	(text := (UpdatingStringMorph on: self commandStack selector: #pushes))
		setProperty: #okToTextEdit toValue: false;
		position: (619@213) + self position;
		color: (Color black);
		font: ((TextStyle default "named: #ComicSansMS") fontOfSize: 26);
		stepTime: 200.
	
	self addMorph: text.

	(text := (UpdatingStringMorph on: self commandStack selector: #moves))
		setProperty: #okToTextEdit toValue: false;
		position: (467@213) + self position;
		color: (Color black);
		font: ((TextStyle default "named: #ComicSansMS") fontOfSize: 26);
		stepTime: 200.
	
	self addMorph: text.! !

!SokoGame methodsFor: 'initialization' stamp: 'mt 11/30/2007 08:53'!
initializeToStandAlone
	"change self appearance and create a first level"
	
	super initializeToStandAlone.

	self blockInputs: false.
	self commandStack: SokoCommandStack new.
	self prototypes: Dictionary new.

	levelSetNumber := 1.

	self
		setNewImageFrom: (self class loadGraphicWithName: 'logo.png');
		associateKeysToActions;
		initializeStatusline;
		initializeButtons;
		initializeFirstLevel.! !

!SokoGame methodsFor: 'creation' stamp: 'mt 7/20/2007 22:41'!
createButton
	"creates an IconicButton for GUI. Buttons are transparent and have no border, that's why a graphic must be set before button is used. After creation, the button is added as a submorph of SokoGame."
	|button|
	(button := IconicButton new)
		initializeAllButLabel;
		target: self;
		borderNormal;
		color: Color transparent;
		actionSelector: #processKey:.
		
	self addMorph: button.
	^button.! !

!SokoGame methodsFor: 'creation' stamp: 'mig 7/20/2007 19:50'!
createPlayfield
	"create playfield and let playfield load the map"
	
	self playfield: 
		(SokoPlayfield newBounds: (0@0 corner: 
			(Point 
				x: self level mapsize x * SokoField tileWidth
				y: self level mapsize y * SokoField tileHeight
		))).

	self playfield
		game: self;
		loadMapWith: (self level fields) with: (self level boxes) with: (self level players);
		position: (0 @ (self height - 25)) + self position;
		x: self x. "centers the playfield to the status bar"
		
	self addMorph: self playfield.
	self handleReplay.! !

!SokoGame methodsFor: 'replay handling' stamp: 'mt 7/20/2007 12:15'!
createReplayCommandFor: someActors to: aDirection
	"The direction will be reversed to avoid a conflict with command handling."
	
	someActors remove: nil ifAbsent: [].
	
	self commandStack push: ( SokoCommand createFor: someActors movingTo: (self class oppositeDirectionOf: aDirection) ).! !

!SokoGame methodsFor: 'replay handling' stamp: 'mt 7/20/2007 12:18'!
doVirtualMoveFor: anActor to: aDirection
	"Changes an actors location without showing the result to the user."

	anActor ifNotNil: [ anActor location: anActor location + (self class offsetFrom: aDirection) ]! !

!SokoGame methodsFor: 'replay handling' stamp: 'mt 7/20/2007 12:22'!
getBoxPushedBy: aPlayer to: aDirection
	"Returns a box if the player would push one by moving into the given direction - otherwise return nil."
	
	^self playfield boxAt: aPlayer location + (self class offsetFrom: aDirection)! !

!SokoGame methodsFor: 'command handling' stamp: 'mig 7/20/2007 19:53'!
doAction: aKey
	"Starts an action associated to aKey - only if both players are standing."

	self playfield playerOne isMoving | self playfield playerTwo isMoving
		ifFalse: [ (self actions at: aKey ifAbsent: []) value ]! !

!SokoGame methodsFor: 'command handling' stamp: 'mig 7/20/2007 20:05'!
handleCustomLevel
	"Enables the user to load a custom level."
	
	|content stream|
	
	stream := (FileList2 modalFileSelector).

	stream
		ifNotNil: [
				content :=  stream upToEnd.
	
				self commandStack clear.
				self playfield delete.
				self levelSet add: content beforeIndex: self levelNumber.
	
				self
					parseSokoLevelFrom: content;
					createPlayfield.
		]! !

!SokoGame methodsFor: 'command handling' stamp: 'mt 11/30/2007 09:03'!
handleCycleLevelSets
	levelSetNumber := levelSetNumber + 1.
	
	levelSetNumber > 4
		ifTrue: [levelSetNumber := levelSetNumber - 4].
	
	self initializeLevelSet.
	self handleLevelSkip: 1.! !

!SokoGame methodsFor: 'command handling' stamp: 'mig 11/13/2007 18:15'!
handleGameDone
	"You'll have to close the game with the X-Halo after the game is done."
	
	(ImageMorph new) 
		setNewImageFrom: (self class loadGraphicWithName: 'cup.png');
		position: self position + (200@50);
		openInWorld.

	self delete.
	! !

!SokoGame methodsFor: 'command handling' stamp: 'mig 7/20/2007 20:05'!
handleLevelDone
	"Checks whether all boxes are on their target fields and prepares everything needed to enter the next level."

	self playfield allBoxesOnTarget & self isInputProcessingAllowed
		ifFalse: [^self].
		
	self startInputProcessing.
	self playfield playerOne startWinAnimation.
	self playfield playerTwo startWinAnimation.
	self levelNumber: self levelNumber + 1.
	self initializeNextLevel: 5.! !

!SokoGame methodsFor: 'command handling' stamp: 'mt 7/17/2007 17:43'!
handleLevelRestart
	"Restarts a level, which means resetting positions of boxes and players as well as clearing the command stack"
	
	self playfield resetLocationsTo: self level players and: self level boxes.
	self commandStack clear.
	self handleReplay.! !

!SokoGame methodsFor: 'command handling' stamp: 'mig 7/20/2007 20:05'!
handleLevelSkip: aNumber
	"Jumps from current level to current level + aNumber if present."
	
	(self levelNumber + aNumber between: 1 and: self levelSet size) ifTrue: [
		self levelNumber: self levelNumber + aNumber.
		self
			startInputProcessing;
			initializeNextLevel: 0.
		].! !

!SokoGame methodsFor: 'command handling' stamp: 'mt 11/29/2007 23:02'!
handleMoveActionTo: aDirection for: aPlayer
	"Initializes player movement if given player can move to a given direction."
	
	|someSokoActors|

	(aPlayer canMoveTo: aDirection)
		ifTrue: [
			"Current SokoPlayer object and moved box need to be added."
			(someSokoActors := OrderedCollection new)
				add: aPlayer beforeIndex: 1;
				add: (self playfield boxAt: aPlayer location + (self class offsetFrom: aDirection));
				remove: nil ifAbsent: [].
		
			"create and execute new command"
			self commandStack push: (SokoCommand createFor: someSokoActors movingTo: aDirection).
			self commandStack top execute.
		].
	
	"start corresponding animation of the player"
	(aPlayer isMoving)
		ifFalse: [
			(self playfield boxAt: (self class offsetFrom: aDirection) + aPlayer location)
				ifNil: [aPlayer startAnimation: #standing to: aDirection]
				ifNotNil: [aPlayer startAnimation: #pushstanding to: aDirection].
		]
	! !

!SokoGame methodsFor: 'command handling' stamp: 'mig 7/20/2007 20:05'!
handleRedoLastUndo
	"Reverses the last undo if there was at least one."
	
	self commandStack redoCommand
		ifNotNil: [self commandStack top execute]! !

!SokoGame methodsFor: 'command handling' stamp: 'mt 7/20/2007 19:58'!
handleReplay
	"Used only once after level creation or level reset. The level has to be fully initialized yet!!"
	
	self level replay ifNotNil: [
		self level replay do: [:direction | |player box|
			player := self playfield playerOne. "could be modified for two-player-solutions"
			box    := self getBoxPushedBy: player to: direction. 
					
			self
				createReplayCommandFor:	{player. box} asOrderedCollection to: direction;
				doVirtualMoveFor: player to: direction;
				doVirtualMoveFor: box to: direction.
		].
	].

	"prepared replay should be invisible to user"
	self commandStack clearToReplayStack.
	self playfield resetLocationsTo: self level players and: self level boxes.! !

!SokoGame methodsFor: 'command handling' stamp: 'mt 7/17/2007 17:51'!
handleUndoLastAction
	"Reverses the last user input if there was at least one."
	
	self commandStack isEmpty
		ifFalse: [
			self commandStack top undo.
			self commandStack pop.
		].! !

!SokoGame methodsFor: 'event handling' stamp: 'mig 11/14/2007 14:02'!
finishInputProcessing
	"If an input has finished, other inputs are allowed again."
	
	self blockInputs: false.
! !

!SokoGame methodsFor: 'event handling' stamp: 'mt 7/17/2007 17:34'!
handlesKeyboard: anEvent
	"Override method for enabling player input"
	
	^true.! !

!SokoGame methodsFor: 'event handling' stamp: 'mt 7/17/2007 17:34'!
handlesMouseOver: anEvent
	"Override method for enabling player input, if the mouse is over the playfield."
	
	^true.! !

!SokoGame methodsFor: 'event handling' stamp: 'mig 11/14/2007 14:03'!
isInputProcessingAllowed
	"Checks whether a player can hit a key and recieves a reaction to this event."
	
	^self blockInputs not.

! !

!SokoGame methodsFor: 'event handling' stamp: 'mt 7/17/2007 17:37'!
keyStroke: aKeyboardEvent
	"Catches a keyboard event and passes it to SokoGame>>processKey: for further handling."
	
	self processKey: aKeyboardEvent keyCharacter.
	
! !

!SokoGame methodsFor: 'event handling' stamp: 'mt 7/17/2007 17:38'!
mouseEnter: anEvent
	"Override method for enabling player input, if the mouse cursor enters the playfield."
	
	anEvent hand newKeyboardFocus: self.! !

!SokoGame methodsFor: 'event handling' stamp: 'mig 7/18/2007 14:26'!
processKey: aKey
	"This method lets the game react to user input, if an input processing is allowed."
	
	"squeak mutex bug workaround"
	(Delay forMilliseconds: 1) wait.
	
	self tryInputProcessing: [ 
		self doAction: aKey. 
	].	! !

!SokoGame methodsFor: 'event handling' stamp: 'mig 11/14/2007 14:03'!
startInputProcessing
	"If an input is started no other inputs are allowed."
	
	self blockInputs: true.
! !

!SokoGame methodsFor: 'event handling' stamp: 'mig 11/14/2007 14:03'!
tryInputProcessing: aBlock
	"Runs aBlock if input processing is allowed at this moment. Blocks inputs before and releases inputs after evaluating the block."
	
	self blockInputs ifTrue: [^self].
	self blockInputs: true.
	
	aBlock value.
	
	self blockInputs: false.

! !

!SokoGame methodsFor: 'converting' stamp: 'rkrk 11/17/2007 21:29'!
parseSokoLevelFrom: aString
	"determine sokoban level format and parse data"
	
	('SWA*' match: aString)
		ifTrue: [self level: (SokoLevel fromSWAFormat: aString)]
		ifFalse: [self level: (SokoLevel fromClassicFormat: aString)].
! !


!SokoGame class methodsFor: 'storage' stamp: 'mig 11/13/2007 18:38'!
addGraphics: aFilename data: aForm
	ImageStorage ifNil: [ImageStorage := Dictionary new.].
	ImageStorage at: aFilename put: aForm.
	
! !

!SokoGame class methodsFor: 'storage' stamp: 'rkrk 11/18/2007 00:23'!
initializeResources

	ImageStorage ifNil: [ImageStorage := Project current changeSet structures at: #ImageStorage]! !

!SokoGame class methodsFor: 'storage' stamp: 'rkrk 11/17/2007 22:45'!
loadGraphicWithName: aFilename
	"loads image form with the specified name. if image load fails, it returns nil"

	self initializeResources.
	^ImageStorage at: aFilename ifAbsent: [ nil ].
	
! !

!SokoGame class methodsFor: 'storage' stamp: 'mig 11/13/2007 18:15'!
matchingGraphics: aPatternString
	^ImageStorage keys select: [:k | aPatternString match: k]! !

!SokoGame class methodsFor: 'parts bin' stamp: 'mig 11/13/2007 18:16'!
descriptionForPartsBin
	"creates information for the object tool"

	^ self
		partName: 'Sokoban'
		categories: #('Games')
		documentation: 'A tricky logic puzzle, created by Hiroyuki Imabayashi in 1982. Tuned by SWA-Group 11 in 2007.'
		sampleImageForm: (self loadGraphicWithName: 'box_standing_up_1.png').! !

!SokoGame class methodsFor: 'parts bin' stamp: 'rkrk 11/17/2007 22:51'!
imageStorage: aDictionary

	 ImageStorage := aDictionary! !

!SokoGame class methodsFor: 'levels' stamp: 'mt 7/20/2007 22:38'!
levelSetWith: aString with: aNumber
	"Creates a collection with all levels used for every new game."
	
	|set|
	
	set := OrderedCollection new.
	
	(1 to: aNumber) do: [:i |	
		set add: (self perform: (aString, i asString) asSymbol)
	].
	
	^set.! !

!SokoGame class methodsFor: 'levels' stamp: 'mt 7/20/2007 22:54'!
swaset1
	"Copyright: Spectrum Holobyte --- Original First Level"
	
	^'SWA
replay:ullluuululldlldddrrrrrrrrrrrrrdrullllllllllllllulldrrrrrrrrrrrrrrrlllllllluuulullddduulldddrrrrrrrrrrrrurdldrulllllllluuullulddduulldddrrrrrrrrrrrrdrulllllllluuulluuulddddduulldddrrrrrrrrrrrurdldrullllllluuulluuurddllddddrrruuullulddduulldddrrrrrrrrrr
!!
4-5#9--|4-#3-#9--|4-#$2-#9--|2-3#2-$2#9-|2-#2-$-$-#9-|3#-#-2#-#3-6#|#3-#-2#-5#2-2.#|#-$2-$9--2.#|5#-3#-#@2#2-2.#|4-#5-9#|4-7#8-'! !

!SokoGame class methodsFor: 'levels' stamp: 'mt 7/20/2007 22:49'!
swaset2
	^'SWA
!!
6-7#|7#3-#-#|#3-.*2>3-.#|2#^4#-3#.#|#2^#-@3#@3#|#2^2-$-$2-$-#|#9-2-#|9#4#'! !

!SokoGame class methodsFor: 'levels' stamp: 'mt 7/20/2007 22:49'!
swaset3
	^'SWA
!!
7-3#|8#.2#|#-@5-v-#|2#-#-3#-2#|-#-$-$<.2-#|-#-5#$2#|-#-$<-@2-.#|-#-5#.2#|-3#3-3#'! !

!SokoGame class methodsFor: 'levels' stamp: 'mt 7/20/2007 22:50'!
swaset4
	^'SWA
!!
2-7#|3#5.#|#@-5v#|2#-<$<$<2#|-#-5^-#|-4#3$2#|2-#-@3-#|2-7#'! !

!SokoGame class methodsFor: 'levels' stamp: 'mt 7/20/2007 22:53'!
swaset5
	^'SWA
!!
9##|#@2-#2.2-#|2#-4#-5#|#.$<2-#2-$2-#|#@^2#->$-#$-#|#-2#.#-2^3-#|#-$.5-4#|4#-5#|3-3#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban1
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-#|#2-#|#2-3#|#.2$@#|#2-.-#|#2-3#|4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban10
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-#|#3-3#|#3$@-#|#3.2-#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban100
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#5-2#|-#-3#2-4#|-#3-2#4-#|-#2-$-4#-#|4#$-5.#|#2-#2-4#-#|4#2$#4-#|-#2-$-#-4#|-#2-@-#-#|-#-4#-#|-#6-#|-8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban101
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|3#-.-#|#2-.-$2#|#2-2$.-3#|3#-.2$@-#|2-2#$-.2-#|3-#-.-3#|3-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban102
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|2-2#2-#|2-#3-5#|2-#7-#|2-#3-#3-#|2-2#4-.2#|3-5#.#|2-6#.3#|2-#5-.2-#|3#2-#$#.2-#|#2-2$-$-4#|#3-$-@-#|3#2-4#|2-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban103
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-9##|2-#3-#4-#|3#-3.-.#-#|#4-2#-2#-#|#4-2#2-#-#|3#2-#@2-#-#|-2#2-2#2-#-3#|2-5#-$#$2-#|3-2#-#-$4-#|4-3#-$2#2-#|5-2#2-5#|6-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban104
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-6#|4#4-#|#4-2#-2#|#-2#5-#|#-#2-#3-#|#2-2$#2$-#|3#$-$-$2#|-2#5-2#|-4#@4#|-#2-.-2.-#|-#-2.-.2-#|-#-.2#3-#|-5#3-#|5-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban105
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|-#2-3#|2#4-2#|#2-*-.-#|#-*$*$-#|2#-.$.-#|-#@2-3#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban106
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|3#2-#|#2-.-2#|#-#*2-#|#-$.#@#|2#$.#-#|#2-$2-#|#3-3#|#2-2#|4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban107
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|-2#2-4#|-#2-2$2-#|-#-#2-#-#|-#-$-$#-#|-#-#2-#-#|-#@#2-#-#|2#-#$#2-#|#-5.2#|#3-4#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban108
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|3-#2-#|2-2#-$3#|2-#2-.2-3#|3#-.$.3-#|#-$.$@$.$-#|#3-.$.-3#|3#2-.2-#|2-3#$-2#|4-#2-#|4-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban109
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#-.-5#|-#$-2$-$-#|-#-2.-.-.#|2#$3-.$-#|#-$.3-$2#|#.-.-2.-#|#@$-2$-$#|5#-.-#|4-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban11
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#.#2-#|#@2$-#|#2.$-#|2#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban110
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-8#|2-#2-#3-#|3#3.-.-#|#4-#-3#|#-@4-#|3#2-#-2#|2-3#-$-#|2-2#-$2-#|3#-$2-2#|#2-$2-4#|#4-#3-#|#2-2#4-#|#7-2#|2#2-#2-2#|-4#2-#|4-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban111
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|2-#2-#|3#2-2#|#2-$-.#-4#|#2-$#.3#2-#|#2-$-.#4-#|5#.#-$2-#|2-3#.#$#@-#|2-#2-.2-$2-#|2-#3-3#2-#|2-2#2-#-4#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban112
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#3-#3-#|#-$3.$-#|#-$*@*$-#|#-$3.$-#|#3-#3-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban113
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#2#|#9-#|#2-*-.-*2-#|2#*$*@*$*2#|#2-*-.-*2-#|#4-#4-#|9#2#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban114
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-5#|4-3#3-#|4-#3-#-#|4-#-#3-#|5#-$-$5#|#3-2#-#-#3-#|#-#-$-3.-$#-2#|#4-#.@.#4-#|2#-#$-3.-$-#-#|-#3-#-#-2#3-#|-5#$-$-5#|4-#3-#-#|4-#-#3-#|4-#3-3#|4-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban115
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-#|5-#-#|4-#3-#|3-#-.$.-#|2-#-.$.$.-#|-#-.$-$-$.-#|#2-$.$@$.$2-#|-#-.$-$-$.-#|2-#-.$.$.-#|3-#-.$.-#|4-#3-#|5-#-#|6-#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban116
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#2-#3-#|#6-#|#2-2#-9##|2#-2#2-#7-#|-#-2#2-#7-#|-#-2#2-$-$-$-$-#|2#-3#-7#@#|#4-.-.-.-.3-#|#3-9#3#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban117
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7-4#|-7#2-#|2#3-2#3-#|#4-#2-$-#|#-#-2#$2-2#|#-#3-$-2#|#@#-.#$-2#|#2-2.2-2#|3#.-3#|2-#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban118
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|5-#3-2#|6#2-$-2#|#4-2#2-$-2#|#5-2#2-$-#|#3.#2-2#3-#|#3-@2-2#$2-#|#3.#-2#-$-2#|5#-#-$2-#|4-#5-2#|4-#2-4#|4-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban119
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#5-3#|-#-3#.2-#|-#-#-.-#-#|2#-#3.2-#|#@3-.4#|#2-#2-#|2#-5#|#-2$3-2#|#2-2$3-#|3#-2$2-#|2-#5-#|2-2#3-2#|3-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban12
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#2-#2-#|-#2-#$-#|2#2-.*+#|#3-#$-#|#3-#2-#|2#2-4#|-#2-#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban120
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#-4#|#2-3#2-6#|#2-#9-#|4#$2-$2#-#-#|-#3-#3-#-$-2#|3#4-2#-2$2-#|#2-2#-$3-#3-#|#-@-#2-8#|#5-2#5-#|#6.#-6#|#6-3#4-#|8#-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban121
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-7#|2-2#-.3-#|-2#2-.3-#|-#-$*.#-2#|-#-#-.2-#|2#-#-.-2#|#2-3#-#|#-#3-@2#|#-3$#2-#|#5-#-#|3#3-#-#|2-#$2#2-#|2-#4-2#|2-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban122
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|-3#2-2#|-#5-#|2#*2-#-#|#-*$*.-#|#2-@2-2#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban123
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|3#3-4#|#3-$2-$-#|#-$2#2-$-#|2#5-#-#|-5#-#-3#|5-#-3.-#|5-2#.3-#|6-2#-@2#|7-#2-#|7-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban124
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#3-#3-#|#-$-*-$-#|#2.#-#2.#|#-$-#-$-#|#-.$@$.-#|#-$-#-$-#|#2.#-#2.#|#-$-*-$-#|#3-#3-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban125
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-9##|5-#8-2#|-5#-4#-$2-#|-#2.-#5-#3-#|-#3-.2-#-$2-#-#|-#2.-4#-#-$2-#|-2#-2#2-#-2$#2-#|2-#-#3-2#4-2#|3#@3#2-6#|#5-#|#5-#|#2-#2-#|4#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban126
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#5-#|-#-2$2-#|-#2-$3#|-#-#2-#|-#-#$-#|-#-#2-#|2#-2#-2#|#4-2.7#|#@3#3.5-#|#3-#.4#-$-#|3#-#.#-$-2$-#|2-#2-.4-#2-#|2-9#2-#|9--4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban127
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#@2-6#|#2-$-#3-#|#.*.*.-$-#|#2-$-5#|2#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban128
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-7#|2-2#5-2#|3#2-3#2-#|#3-#3-#-#|#@$3*.-#-#|2#6-#-#|-4#-2#2-#|4-#4-2#|4-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban129
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7-4#|8#2-#|#5-$3-#|#2-2#.2#2-#|2#$2#2-.-2#|-#2-.-$#-2#|-#-3#.#2-#|-#-3#-@2-#|-#3-$-4#|-#2-4#|-4'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban13
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-3#|#5-#|#5-#|3#.3#|#-$*$-#|#2-+2-#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban14
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|2#2-3#|#-.$2-#|#@.$2-#|#-.$-2#|2#2-2#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban15
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-4#|#2-#2-#|#.$2*@#|2#4-#|-#3-2#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban16
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-4#|2-3#2-#|2-#-2$-#|-2#-#2-#|2#-.#$@#|#6-#|#-2.4#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban17
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|-#$#@#|2#-$-#|#3-2#|#.*.-#|#4-#|6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban18
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-2#|-#$#@-#|-#-$2-#|2#2-3#|#-$.2-#|#.-.2-#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban19
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-#|#-3$.#|2#-#@.#|-#-#-.#|-#2-#-#|-2#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban2
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|2#.#-#|#2-@-#|#2-$-#|#-#*2#|#3-#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban20
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|-#2-3#|-#$3-#|-#-.#-#|2#*.2-#|#-$-3#|#-@-#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban21
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|4#2-#|#.-.2-2#|#2-#-@-#|2#-#3-#|2#-2#2-#|#-$2-3#|#2-$-#|#-#-2#|#3-#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban22
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9#|-#4-#2-#|-#-$-$3-#|-2#-3#2-#|3#-#-#@3#|#3-3#3-#|#-#-.-.3-#|#3-7#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban23
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#-5#|-#3-3#3-#|-#@$2-2#2.-#|3#$#6-#|#3-2#-2#2-#|#7-4#|#3-#3-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban24
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|6#3-#|#3-2#-#-#|#-$@$4-#|3#-3#-3#|#9-2#|#3-3#-2.-#|5#4-#-#|4-#-#2-#-#|4-#2-2#2-#|4-2#4-2#|5-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban25
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#3-2#|#-.$.-#|#-$#$-#|#-.$.-#|#4-2#|2#-@2#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban26
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#-3#$-#|#-#2-$-#|#-#.*$@#|#-#.#2-#|#2-.#2-#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban27
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#2-+2-#|#-*$*-#|#.-#-.#|#2-#2-#|#2-#2-#|#2-#2-#|#-$#$-#|#2-#2-#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban28
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-7#|2-#5-#|3#-3#-#|#-2.*3-#|#2-2$@-2#|4#2-2#|3-#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban29
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-#|#-2#$3#|#-#-$2-#|#-@.*.-#|2#5-#|-#2-4#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban3
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|4#2-#|#2-#2-#|#-.-.-#|#-@2$-#|#-#-3#|#3-#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban30
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9-5#|9-#3-#|9##-#-#|#.5-#2-$2-#|#.2-@2-#4-2#|#.#-7#2-#|#9-2$-#|2#2-5#4-#|-4#3-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban31
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-8#|2-#2-#3-#|2-#2-$3-#|2-#2-2#$2#|4#-2#2-#|#-@3.#$-#|#8-#|6#2-2#|5-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban32
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#4-#-#|3#2.$.#|2-#-#$2#|2-#2-@-#|2-2#-$-#|3-#-#-#|3-#3-#|3-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban33
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3#-7#|2#-4#3-#|#-2#-3.#-#|-3#$3-#-#|2#2-2$3#-#|2#-@6-#|9#2#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban34
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-4#|#2-.#2-#|2#-2.2-2#|-#-2#-@-#|-#-#4-#|-#-$-4#|-#-$2#|-#-$-#|-#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban35
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9##|-#2-2#4-2#|-#5-2#2-#|-#-#-$#2-#-#|-#-#2-@-$#-#|-#-#2-#$3-#|-#-3#2-4#|2#-.3-2#|#2-.4#|#2-.#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban36
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-6#|4-#4-2#|-4#-2#2-#|2#6-#-#|#-@$2*.-#-#|#3-#-2#2-#|5#4-2#|4-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban37
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|2#-#-2#|#-$3-2#|#2-$#.-#|2#-$-.-#|-#2-#.-#|-4#-@#|4-#2-#|4-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban38
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-6#|2-#4-#|3#-2#-#|#-3.2-#|#2-$-3#|#-#$2#|#2-$-#|#2-@-#|6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban39
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|2#4-#|#2-2#-#|#@#-$-#|#2-*2.#|2#-#$3#|-#5-#|-3#3-#|3-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban4
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#-@-4#|#2-#2-.-2#|#-#6-#|#-2$-#.2-#|2#4-4#|-2#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban40
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|2#-.-#|#2-*-#|#-#-2#|#2-$-#|2#-*-#|-#-@-#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban41
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-4#|#-#-.2-#|#-#$.2-#|#-@$*#-#|4#3-#|3-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban42
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#5-3#|2#-3#$2-#|#2-2.-$2-#|#2-.2#$-2#|3#-#-@2#|2-#3-2#|2-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban43
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|5-#-@2#|6#-$-2#|#2-.-#-$2-#|#6-$#-#|2#-2.#4-#|-2#2-6#|2-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban44
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-4#|-4#2-3#|-#5-$-#|-#2-2$-#-#|-#-#-@#2-#|2#-4#2-2#|#2-3.4-#|#-3#-#3-#|#5-5#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban45
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-3#2-5#|4#-4#3-#|#2-3#6-#|#-2.2-4$2-#|#-2.2-#-@#2-#|9#4#|6-#2-#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban46
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#2-#3-#|#6-#|#2-2#-3#|2#-2#3-4#|-#-2#-3$@-#|2#-2#-#4-#|#-.-.-.-4#|#3-5#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban47
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-3#|#-$-@2-#|#2-3#-#|#-2$-$-#|#5-3#|3#-2#2-#|#-4.2-#|#7-#|#2-6#|4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban48
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|-5#3-#|2#2-+2-#-#|#-2$.2$2-#|#2-#.#-3#|2#2-.2-#|-7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban49
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#3-#|#4-#|#-.$.2#|2#$#$-#|-#.$.-#|-#4-#|-#-@-2#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban5
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-#|#-2$-3#|3#-@2-#|2-#2-.-#|2-2#-.2#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban50
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-8#|-#2-#3-#|2#2-#$2-#|#-.*@*.-#|#2-$#2-2#|#3-#2-#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban51
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#2-$.2-#|#2-$.2-#|3#2-3#|#2-$.2-#|#@-$.2-#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban52
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|3-#2-#|3-#$-#|3-#2-#|4#@3#|#2-$3-#|#2-2.*-#|#3-#2-#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban53
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|-#4-#|-#.-2.2#|3#$-@-#|#-$2-$-#|#3-4#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban54
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|4-2#3-#|4-#2-#-#|4-#2-@-#|4-#4-#|2-5#.3#|2-#4-.2-#|3#-#$#.2-#|#2-2$2-4#|#-#4-#|#3-4#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban55
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|-3#2-2#|-#-$-$-#|-#3-#-#|-2#$3-#|2-#2-#-#|2-2#-#-#|2-#.-#-#|2-#.2#-#|3#.2#-2#|#7-#|#3-@3-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban56
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-5#|2-2#3-#|3#-.#-#|#2-$*$@#|#3-.#-#|3#-#2-#|2-#3-2#|2-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban57
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-5#|-3#3-#|2#5-#|#-2*$-2#|#2-*-.#|3#-#@#|2-#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban58
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-4#|-4#2-2#|-#4-$-#|-#-#2-#-#|2#-#3$@#|#-2.2-3#|#-2.-2#|3#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban59
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|-#4-3#|-#-$2-$-#|-2#$#-#-#|3#-#@#-2#|#-.-.-.2-#|#3-2#3-#|9##'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban6
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|4#2-#|#@.*2-#|#2-#2-3#|4#2-$-#|3-#2-#-#|3-2#3-#|4-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban60
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#4-5#|-#5-6#3-#|2#6-@-3.3-#|#2-9##-3#|#-$2-$3-$5-#|#2-#3-#3-#3-#|9#7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban61
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-#|#3-6#|#4$-$-@#|#5.3-#|9##'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban62
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|3-#2-3#|3-#-.2-#|3-#$.@-#|4#-.$-#|#2-2$.3#|#5-#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban63
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-5#|#3-$-$-3#|2#-$4-$-2#|-6#-2.-#|5-#.-.-@#|5-#5-#|5-3#2-2#|7-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban64
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#2-2#3-2#|#-$-2$*@-#|#2-#-.-#-#|2#-#.-.2-#|-#3-5#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban65
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-#|#-2#-2#|#-#-*-2#|#-#@*2-2#|#-#-*3-#|#-#-*-$-#|#-2#-#.2#|#4-3#|6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban66
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|5-#3-#|5-#-#-#|5-#3-#|7#$-#|#4-$2.$5#|#-#-$.2-.#3-#|#3-#.2-.$-#-#|5#$2.$4-#|4-#-$7#|4-#3-#|4-#-#-#|4-#-@-#|4-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban67
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|2-2#2-2#|-2#-*2-2#|2#-$-.$-2#|#2-.-@-*-#|#-*3-.2-#|2#-$.-$-2#|-2#2-*-2#|2-2#2-2#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban68
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-#|4-#.#|3-#-$-#|2-#5-#|-#2-3*2-#|#.$-*@*-$.#|-#2-3*2-#|2-#5-#|3-#-$-#|4-#.#|5-#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban69
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#-.-.-#|#.3$.#|#-$@$-#|#.3$.#|#-.-.-#|7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban7
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|3#3-#|#2-$#-#|#2-.$-#|2#-2#.#|-#3-@#|-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban70
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#2-#3-#|#2-#2.-#|#-5$#|#2-#3.#|#2-#3-#|#2-@3-#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban71
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#3-#2-#|#-$.$.-#|2#.2-$-#|#-$2-.2#|#-.$.$-#|#2-#2-@#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban72
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#7-#|#-*$*$*-#|#-$3.$-#|#-*.-.*-#|#-$3.$-#|#-*$*$*-#|#6-@#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban73
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#7-#|#-.$.$.-#|#-$.$.$-#|#-.$@$.-#|#-$.$.$-#|#-.$.$.-#|#7-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban74
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#7-#|#-$.$.$-#|#-.$.$.-#|2#$.@.$2#|#-.$.$.-#|#-$.$.$-#|#7-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban75
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#3-#3-#|#-.$.$.-#|#-$.$.$-#|2#.$@$.2#|#-$.$.$-#|#-.$.$.-#|#3-#3-#|9#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban76
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|-#2-.-3#|2#-$.3-#|#2-$*2$-#|#2.*@*2.#|#-2$*$2-#|#3-.$-2#|3#-.2-#|2-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban77
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|2-#3-3#|-2#-#3-3#|-#2-.$#3-#|2#-#$.$.#-#|#2-$.@.$2-#|#-#.$.$#-2#|#3-#$.2-#|3#3-#-2#|2-3#3-#|4-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban78
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|2#5-2#|#2-$.$2-#|#-$#.#$-#|2#2.@2.-#|#-$#.#$-#|#2-$.$2-#|#3-#2-2#|8#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban79
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-4#|-4#2-#|-#5-#|2#.#-#-2#|#@$-$#2-#|#-.$4-#|2#.$2#2-#|-#.-5#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban8
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#3-@2-#|#3-*2-#|3#.$3#|2-#-*-#|2-#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban80
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#-5#|2#2-3#3-#|#2-.-#2-$-#|#-.-.$-$-2#|3#*2#-#-#|2-#2-#-@-#|2-#2-5#|2-#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban81
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#2-#2-3#|-#2-#2-.-3#|-#3-$-#-@-#|-2#-#-$-$2-#|2-#-2#2.4#|2-#2-#2-#|3#-3#-3#|#5-$3-#|#3-3#.2-#|5#-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban82
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9##|-#8-#|-#.4#3-#|2#.$-@-2$-#|#-.*.$-#2-#|#-3#-2#-2#|#8-#|9##'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban83
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#-4#|#-.2-3#2-#|#6-@2-2#|#4.#-$#2-#|6#-$3-#|5-2#$-$-#|6-#3-2#|6-#-$2#|6-#2-#|6-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban84
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#2-2#2-#|#2-2.2-#|#-.2-.-#|3#-4#|-#4-2#|-#-2$@-#|-3#-$-#|3#2-#-#|#4-$-#|#4-3#|6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban85
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8-4#|8-#2-#|6-3#2-#|5-2#4-#|5-#2-#$3#|5-#-$-$2-#|5-2#$4-#|7#2-4#|#5-#2-2#|#2-@2-2#2-#|#2-#2-4.#|#4-6#|6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban86
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|-2#3-#|-#2-#-#|2#4-#|#2-$-4#|#2-2$#.-#|3#$4-#|2-#2-#2-#|2-4#.-#|3-#@#.-2#|3-#2-.2-#|3-#5-#|3-7#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban87
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|5-#2-3#|4-2#-.2-2#|4-#.-.3-#|4-#.2-#@-#|4-2#-2#2-#|3-2#2-5#|2-2#-$-#|-2#-$2-#|2#-$2-2#|#-$2-2#|#3-2#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban88
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|-#.-.-#|-#2-*.2#|3#$-@-#|#-$2-$-#|#3-4#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban89
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#-#.#2-#|#2-*3-#|2#$*$-2#|#2-*@2#|#-#.2#|#3-#|5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban9
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-#|#-#$@#|#-.*.#|#-#$-#|#4-#|6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban90
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|-#3-2#|-#$*$-#|2#.-.-#|#-.@.2#|#-$*$#|2#3-#|-#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban91
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|2-#2-#|2-#2-#|2-#2-3#|3#$-$-2#|#2-$@$2-#|#3-#3-#|6#-2#|2-2#-.-.#|2-#2-.-.#|2-#5-#|2-#2-4#|2-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban92
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#4-4#|-#-@2-6#2-#|-#2-#3-$5-#|2#-4.#-$-#2-#|#3-2#-2#-$2-2#|#6-3#-$-#|8#-2#2-#|9--4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban93
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-4#|2-3#2-#|-2#-.2-#|2#5-#|#-.$.-2#|#-$-3#|#-.$4#|3#4-#|-2#$#2-#|-#2-#2-#|-#2-@-2#|-3#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban94
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7-6#|4-4#4-3#|4-#4-2#3-#|-4#-3#2.2#-4#|-#2-#2$5-#4-#|2#2-$-$-#3.-@-#-#|#2-#2-$-5#-#2-#|#4-4#2-#4-2#|2#3-#5-#3-2#|-5#5-5#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban95
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#4#|#7-#3-#|#4-2#-#3-#|2#-3#-$-$-2#|#@3.#-3$-#|#9--#|2#2.8#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban96
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|5-#2-#|-5#2-#|-#2-$-$-#|-#-.#2-3#|-#-.#2$2-2#|2#-.#5-#|#2-*3#@2-#|#8-2#|2#-.6#|-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban97
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#4-5#|#3-6#3-#|#9--#-#|2#-7#-#-#|-#-#5-#-#-#|-#-#2$-5.-#|2#-#3-7#|#2-#$#@#|#-$-$2-#|#2-#2-2#|4#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban98
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-3#|#-#-$-3#|#-#-$3-#|#-#.$2#@#|#-#.$3-#|#2-.5#|2#-.2-#|-#4-#|-6#'! !

!SokoGame class methodsFor: 'levels-masmicroban' stamp: 'mt 7/20/2007 21:22'!
masmicroban99
	"Mas-Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|2-#3-#|2-#3-#|2-#2-3#|3#.-#-5#|#2-.-3#3-#|#2-.-#-$3-#|#-#.2#-$-$-#|#2-.-@2-2$2#|2#2-3#3-#|-4#-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban1
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#-.#|#2-3#|#*@2-#|#2-$-#|#2-3#|4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban10
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-5#|6-#.2-#|6-#.#-#|7#.#-#|#-@-$-$-$-#|#-#-#-#-3#|#7-#|9#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban100
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#-@#2-#|#.$3-#|#.-#-$2#|#.$#3-#|#.-#-$-#|#2-#3-#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban101
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|2-#3-#|2-#-#-7#|2-#2-*2-#3-#|2-2#-2#3-#-#|2-#5-#*2-#|3#-#-#-#-3#|#2-*#$+3-#|#-#3-2#-2#|#3-#2-*2-#|7#-#-#|6-#3-#|6-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban102
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#2#|#4.#4-#|#2-#3-2$-#|#2-@2-2#2-#|#5-2#$-#|6#2-$-#|5-#4-#|5-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban103
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-5#|2-#-.-2#|3#-$2-#|#-.-$#@#|#-#$-.-#|#2-$-3#|2#-.-#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban104
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-5#|5#3-#|#4-$2-#|#2-$#$#@#|3#-#3-#|2-#-3.-#|2-3#2-2#|4-#2-#|4-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban105
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#-4#|2#2-3#2-2#|#3-#-#3-#|#2-*.-.*2-#|3#$3-$3#|-#3-@3-#|3#$3-$3#|#2-*.-.*2-#|#3-#-#3-#|2#2-3#2-2#|-4#-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban106
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-8#|-#6-#|-#@3-$-#|2#-3#$-#|#-5.3#|#-$-$-$2-#|6#-#-#|5-#3-#|5-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban107
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#-$3*-#|#-*2-*-#|#-*2-*-#|#-3*.-#|#5-@#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban108
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#5-5#|#2-3#3-#3-2#|#4-#3-#$-$-#|#2.#-5#-#2-#|#2-@4-#-$-$-#|#2.#9-2#|2#3-9#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban109
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-7#|#-#5-#|#-#-#-#-#|2-#-@-$-#|3#-3#-#|#3-3#-#|#-$2-2#.#|2#-$2-#.#|-2#-$2-.#|#-2#-$#.#|2#-2#-#.#|3#-#3-#|3#-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban11
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-6#|2-#4-#|2-#-2#@2#|3#-#-$-#|#-2.#-$-#|#7-#|#2-6#|4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban110
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|2-#2-#|2-#-$4#|3#.-.2-#|#-$-#-$-#|#2-.-.3#|4#$-#|3-#-@#|3-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban111
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-4#|#4-3.#|#4-3.#|6#2-#|2-#2-#2-#|2-#-2$-2#|2-#-@$2-#|2-#-2$2-#|2-2#-$#-#|3-#4-#|3-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban112
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#3-4#|#2-3$2-#|#-#3-$-#|#3-$2#-2#|3#2-#.2-#|2-#2-#3-#|-5#-3#|-#3-#-2#|-#-@4.#|-#6-#|-#3-#2-#|-8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban113
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-5#|2-2#3-#|3#2-#-#|#4-.-#|#2-2#-5#|#2-.-.-#2-2#|#2-#-@-$3-3#|5#.-#2-$2-#|4-4#2-$2-#|7-2#-$-2#|8-#2-2#|8-#2-#|8-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban114
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-3#|#2-#-$-#|#2-$-@-#|2#-2#-5#|#2-#6.#|#-$-$-$-$-#|2#3-6#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban115
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-5#|5#3-4#|#5-#4-#|#2-#5.2-#|2#2-2#-#-3#|-#2$@3$-#|-#5-3#|-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban116
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|3-3#3-#|4#5.#|#-@5$-#|#5-#-2#|5#3-#|4-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban117
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#-4#|-#2-3#2-2#|-#6-@-#|2#2.3#3-#|#6-#2-#|#3.#$2-#-#|#-2#-2$-$-#|#2-$4-3#|4#2-3#|3-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban118
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#3-2#|#2-$2-2#|#-$-$2-2#|3#$#-.-2#|2-#-#-.2-#|-2#-2#.2-#|-#-@2-.-2#|-#3-#2-#|-8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban119
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-6#|2-#4-2#|-2#-2#2-#|-#-2$-#-#|-#-@$-#-#|-#4-#-#|4#-#2-#|#2-3.-2#|#5-2#|7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban12
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-2#|#-$2-#|2#-$-4#|-3#@.2-#|2-#2-.#-#|2-#5-#|2-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban120
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-4#|7#2-#|#-$6-2#|#-$5#2-#|#2-@#2-#2-#|2#-2#2.3-#|#2-#-2.4#|#-$2-3#|#-$3#|#2-#|4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban121
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|-#-.2-#|2#$.#-#|#2-*2-#|#-2.3#|2#$-#-5#|2#-2#-#3-#|#2-4#-#-#|#3-@-$-$-#|2#2-#5-#|-9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban122
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-3#|#-#$2-#|#-$3-#|#-$-$-#|#-$#2-#|#2-@3#|2#-8#|#6-3.#|#9-#|8#2.#|7-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban123
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#-$-2$-8#|5#-@2#.-.2-#|4-#$2-#-.3-#|4-#3-#.-.-2#|4-#$#-2#-#-#|4-#8-#|4-#2-3#2-2#|4-#2-#-4#|4-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban124
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#5#|#6-#5-#|#-$@2$-#-.-2.#|2#-2#-3#-2#-#|-#-#7-#-#|-#-#3-#3-#-#|-#-9#-#|-#9-2-#|-9#4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban125
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-5#|6-#3-2#|6-#-$2-#|8#-#@2#|#-.2-#-$-$2-#|#8-$#-#|#3.5#3-#|5#3-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban126
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9#2#|2#7.2-#|#-7$@-#|#3-#-#-#-2#|#-#-#5-#|#3-7#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban127
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2#-4#|4#2-4#|-#-$-$.2-#|2#-#2-.$-#|#3-2#.3#|#2-$2-.-#|#-@-#3-#|#2-6#|4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban128
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-9#|3#3-#3-#|#-*-$-.-.-#|#3-$-2#-2#|4#*#3-#|-#2-@2-3#|-#3-3#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban129
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-9#|3#-@-#3-#|#-*-$-*2.-#|#3-$-#3-#|4#*#2-3#|-#5-2#|-#3-3#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban13
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#.-2#|#.@-#|#.-$#|2#$-3#|-#-$2-#|-#4-#|-#2-3#|-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban130
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#2-5#|#3-4#2.-#|#-3$6-#|#3-$#2-2.-#|3#-@#2-2#-#|2-#2-2#4-#|2-9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban131
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-#|#-.-#|#.@.3#|2#.#2-#|#2-$2-#|#-$3-#|2#2$2-#|-#2-3#|-#2-#|-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban132
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#-@3#|#.*2-5#|#2.#2$-$-#|2#7-#|-#-#-2#2-#|-#3-5#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban133
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#2-.-.3#|-#-.-.-.-#|3#-4#-#|#2-@$2-$-#|#2-2$2-$-#|4#3-3#|3-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban134
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8-4#|9#2-#|#3-2#-$3-#|#2-$3-2#2-#|3#-#.-.#-2#|2-#-#.-.#$2#|2-#-#3-#2-#|2-#-@-$4-#|2-#2-7#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban135
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-5#|#-2$#@2#2.#|#-#7-#|#2-$-#-#2-#|4#-$2-2.#|3-8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban136
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#5-#|2#-3#$2#|#.$3-@-#|#-2.-#$-#|#.2#2-$-#|#4-4#|6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban137
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7-4#|6-2#2-3#|4#2-#2-$2-#|#2-4#-$-$-#|#3-2.#-#$2-#|#2-#3-@2-3#|2#-#2.#-3#|-#-2#-#-#|-#6-#|-8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban138
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|3#2-#|#4-3#|#-#-.-.#|#-@-3.4#|#-#-#-#3-2#|#3-#-2$3-#|5#2-$-$-#|4-2#$-#-2#|5-#4-#|5-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban139
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|2#2-4#|#3-3.#|#3-3.#|#3-#-2#|#3-#@-4#-4#|5#-$3-3#2-#|4-#2-2#$-$3-#|3-3#5-2$2-#|3-#-$2-2#3-3#|3-#4-6#|3-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban14
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-#|#-#-#-#|#.-$*@#|#3-3#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban140
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#-5#|#2-#3-3#3-#|#6-2#-$2-#|#.#-@-2#-$2-2#|#.#3-#-$2-2#|#.#4-$2-2#|#.-2#-5#|2#4-#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban141
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-8#|2-#2-#-.-#|2-#3-.*.#|2-#2-#-*-#|4#$2#.2#|#6-$-#|#-$-2#-$-#|#3-@#3-#|9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban142
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|2-#2-#|2-#2-4#|3#$.$2-#|#2-.@.2-#|#2-$.$3#|4#2-#|3-#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban143
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-4#|#-$3-#|#-.#2-#|#-$#-2#|#-.2-#|4#-#|3-#-#|-3#-3#|-#2-$2-#|2#-#$#-2#|#-$-@-$-#|#-2.#2.-#|3#3-3#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban144
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|-3#2-5#|-#-2$-#3-#|-#-$-.-.2$2#|-#-2.-#.-$-#|3#-#2*-.2-#|#2-.-2*#-3#|#-$-.#-2.-#|2#2$.@.-$-#|-#3-#-2$-#|-5#2-3#|5-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban145
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-5#|3-#-@-#|2-2#3-2#|3#.3$.3#|#2-$3.$2-#|#2-$.#.$2-#|#2-$3.$2-#|3#.3$.3#|2-2#3-2#|3-#3-#|3-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban146
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|2#2-.2-2#|#-.3$.-#|#-$.-.$-#|#.$-@-$.#|#-$.-.$-#|#-.3$.-#|2#2-.2-2#|-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban147
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7-5#|8#3-#|#.3-.2-@#.#|#2-3#5-#|2#-$2-#4-#|-#-$3-5#|-#-$#2-#|-2#-#2-#|2-#3-2#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban148
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#2#|#2-.2-#3-#|#-#.2-@3-#|#2-#2.#-7#|2#2-2#-2$-$-$-#|-2#9-2-#|2-9#4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban149
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|2#2-3#|#@$3-#|3#-$-#|-#2-6#|-#2-$4.#|-#2-#-4#|-2#-#-#|-#-$#-#|-#4-#|-#2-3#|-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban15
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-3#|6#@2#|#4-.*-#|#3-#3-#|5#$#-#|4-#3-#|4-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban150
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|-5#2-#|-#5-$7#|2#-2#-2.#2-3.#|#-$-2$#$2-@3-#|#8-3#2-#|7#2-#-4#|6-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban151
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|3-#2-#|-3#2-#|2#2-$-#|#3-#-#|#-#2$-6#|#-#3-#3-.#|#2-$2-@3-.#|3#2-4#2.#|2-4#2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban152
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#-4#|#5-#4-#|#.2#2-#$2#2-#|#3-#5-#2-#|#$2-#-3#2-#2-#|#-#6-#2-#-#|#-#-4#2-#-#-#|#.-@4-$-*-.-#|9#6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban153
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#4#|#.#-@#2-#3-#|#.#2$3-#-$-#|#.#2-#-$#3-#|#.#-$#2-#-$2#|#.#2-#-$#2-#|#.#-$#2-#-$#|#2.2-#-$3-#|#2.2-#2-#2-#|9#3#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban16
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|-#2-4#|-#5-2#|2#-2#3-#|#.-.#-@$2#|#3-#-2$-#|#2-.#4-#|9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban17
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#-@-#|#3.#|#3$2#|#4-#|#4-#|6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban18
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-#|#.-.2-#|#-2#-2#|#2-$-#|3#$-#|2-#@-#|2-#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban19
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#3-2.-#|#2-@2$-#|5#-2#|3-#2-#|3-#2-#|3-#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban2
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-#|#-#@-#|#-$*-#|#-.*-#|#4-#|6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban20
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-3#|#2-@2$2.#|4#-2#-#|2-#5-#|2-#2-4#|2-#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban21
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-4#|#-.-.-#|#-2$#@#|2#4-#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban22
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-3#|#.-.2-#|#3-#-#|2#-#2-#|-#@2$-#|-#4-#|-#2-3#|-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban23
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#2-*2-#|#5-#|2#-#-2#|-#$@.#|-#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban24
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'#-5#|2-#3-#|3#2$@#|#3-3#|#5-#|#-.-.-#|7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban25
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|-#2-3#|-#-2$-#|2#3.-#|#2-@$-#|#3-3#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban26
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#-@-#|-#3-#|3#$-#|#-3.#|#-2$-#|3#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban27
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#3-.#|#-2#-2#|#2-2$@#|#-#3-#|#.2-3#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban28
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-#|#-@-#|#-2$3#|2#.-.-#|-#4-#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban29
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-5#|5-#3-2#|5-#4-#|-6#3-#|2#5-#.-#|#-$-$-@2-2#|#-6#.#|#8-#|9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban3
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|3#2-4#|#5-$-#|#-#2-#$-#|#-.-.#@-#|9#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban30
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-3#|#-2$-#|#3.-#|#-@$-#|#3-2#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban31
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|-2#2-#|2#@$.2#|#-2$2-#|#-.-.-#|3#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban32
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|2#2-3#|#5-#|#.2*$@#|#3-3#|2#2-#|-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban33
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#.-#2-#|#2-$2-#|#.-$#@#|#2-$2-#|#.-#2-#|7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban34
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|3#2-4#|#7-#|#@$3*.-#|#7-#|9#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban35
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|2#2-#|#.-$#|#.$-#|#.$-#|#.$-#|#.-$2#|#3-@#|2#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban36
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-9#3#|#-$-$-$-$-$-@-#|#-5.7-#|9#6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban37
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-3#|5#-#.#|#3-3#.#|#3-$-#.#|#-$2-$2-#|5#@#-#|4-#3-#|4-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban38
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9##|#8-#|#-2#.3#-#|#-#-2$-.-#|#-.-@$2#-#|5#4-#|4-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban39
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-4#|#-#-#-.#|#4-$-3#|3#-#$.2-#|#3-#@3-#|#-#-6#|#3-#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban4
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#-.2*$@#|#6-#|5#2-#|4-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban40
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|2#3-2#|#-3$-#|#-.+.-#|7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban41
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-#|#@3$-2#|#2-#3.#|2#4-2#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban42
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|3-#2-#|3-#@-#|4#$.#|#3-$.#|#-#-$.#|#4-2#|6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban43
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|5-#-@#|5-#2-#|6#-.#|#3-$2-.#|#2-2$#-.#|#4-4#|3#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban44
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#@$.#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban45
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#3.-#|#2-$-#|#-#$2#|#2-$-#|#2-@-#|6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban46
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|2#4-#|#2-2#-#|#-#-$-#|#2-*-.#|2#-#@2#|-#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban47
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-7#|3#5-#|#-$-$3-#|#-3#-5#|#-@-.-.3-#|#3-3#3-#|5#-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban48
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#2-@-#|#2-#-2#|#-.#2-2#|#-.3$-#|#-.#3-#|4#3-#|3-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban49
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#-@2-#|#-$#-#|#-$2-#|#-$-2#|3#-4#|-#2-#2-#|-#3.2-#|-#5-#|-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban5
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|-#5-#|-#-.$.-#|2#-$@$-#|#2-.$.-#|#6-#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban50
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|3#2-5#|#2-$2-@2.#|#-$4-#-#|3#-4#-#|2-#6-#|2-8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban51
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-3#|#4-3#|#2-$*@-#|3#-.#-#|2-#4-#|2-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban52
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|3#-@#|#2-$-#|#2-*.#|#2-*.#|#2-$-#|3#2-#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban53
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#.-.2#|#-*-*-#|#2-#2-#|#-$-$-#|2#-@-2#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban54
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6-6#|6-#4-#|2-5#-.2-#|3#2-3#.2-#|#-$2-$2-.-2#|#-@2$-#-.-#|2#4-5#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban55
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#-@-#2-#|#6-#|5#$-#|4-#2-3#|-2#-#$-2.#|-2#-#2-3#|4-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban56
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-3#|#2-$2-#|2#*-.-#|-#3-@#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban57
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|2-#2-#|2-#@-#|2-#2-#|3#-4#|#4-*-#|#2-$3-#|5#.-#|4-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban58
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-4#|#.*$2-#|#-.$#-#|2#-@2-#|-#3-2#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban59
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#3#|#9--#|#-7#-@2#|#-#9-#|#-#2-$3-#2-#|#-2$-5#2-#|3#2-#-#-3.#|2-4#-#4-#|7-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban6
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#-5#|#4-3#3-#|#-2$5-#@#|#-$-#3.3-#|#3-8#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban60
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9#|-#7-#|2#@5#-#|#2-#3-#-#|#2-#3-$.#|#2-2#$2#.#|2#$2#2-#.#|#3-$2-#.#|#3-#2-3#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban61
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#6-#|#-4#-#|#-#3.@#|#-3#$3#|#-#5-#|#2-2$-$-#|4#3-2#|3-#.3#|3-3#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban62
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-9##|4#4-2#2-#|#2-3$4.$@#|#6-3#2-#|#3-4#-4#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban63
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#3-4#|#3-5#-.#|#7-$2-8#|3#2-4#-.$4-@-#|2-#2-#2-#2-4#3-#|2-4#2-4#2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban64
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-6#|2#4-#|#3-$-#|#2-2$-#|3#-.5#|2-2#.#-@-#|3-#.2-$-#|3-#.-4#|3-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban65
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-6#|2-#4-#|2-#2-$-#|-4#$-#|2#-$-$-#|#4.#-2#|#5-@-#|2#2-#3-#|-8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban66
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-3#|3-#@#|-3#$3#|2#2-.2-2#|#2-#-#2-#|#-#3-#-#|#-#3-#-#|#-#3-#-#|#2-#-#2-#|2#-$-$-2#|-2#.-.2#|2-#3-#|2-#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban67
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-2#|#-#2-#|#@$*.2#|2#2-.-#|-#-$#-#|-2#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban68
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|-#2-6#|2#4-$2-#|#-.#-$3-#|#-.#$5#|#-.@-#|6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban69
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#2-4#|#2-4#2-#|#2-#2-#2-#|#2-#4-$2#|#2-.-.#$2-#|#@-2#-#-$-#|#3-.-#3-#|9#2#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban7
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7#|#5-#|#-.$.-#|#-$.$-#|#-.$.-#|#-$.$-#|#2-@2-#|7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban70
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#-@-4#|#6-#|#-$-2$-#|2#$2#2-#|#3-4#|#-2.2-#|2#2.2-#|-3#2-#|3-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban71
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#2#|#5-#3-3#|#-$@$-#-.2-.#|#-2#-3#-2#-#|#-#7-#-#|#-#3-#3-#-#|#-9#-#|#9-2-#|9#4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban72
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|-2#2-5#|-#2-$2-@-#|-#2-$#3-#|4#-5#|#2-#3-#|#4-$-#|#-2.#2-#|#2-.4#|#2-2#|4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban73
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-5#|#-2$-$-#|#6-#|2#-2#-2#|#3.#@#|#-3#-2#|#6-#|#2-#3-#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban74
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-4#|-#2-7#|-#$-@#3-.#|2#-#2$3-.#|#2-$2-2#2.#|#3-#-5#|3#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban75
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|2#-4.2#|#3-6#|#3-$-$-@#|3#2-$-$-#|2-3#4-#|4-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban76
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|2#3-#|#4-5#|#2-#.#3-#|#@-#.#-$-#|#2-#.#2-2#|#4-#2-#|2#2-2#2$#|-2#5-#|2-#2-4#|2-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban77
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9##|#-@-4.-#|#3-4#$2#|2#-#2-$-$-#|-#-$6-#|-#3-6#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban78
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-7#|2#5-2#|#2-$-$2-#|#-$-$-$-#|2#-3#-4#|-#@2-5.#|-2#5-3#|2-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban79
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9#|-#4-#2-#|2#-$#$#2-#|#2-.$.@2-#|#2-.#4-#|9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban8
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-6#|2-#-2.@#|2-#-2$-#|2-2#-3#|3-#-#|3-#-#|4#-#|#4-2#|#-#3-#|#3-#-#|3#3-#|2-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban80
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4#|#2-7#|#2-.-2#-.#|#-$#4-.#|2#-2#-#-.#|-#4-#2-#|-4#-#2-#|2-#-@$-3#|2-#-2$-#|2-#4-#|2-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban81
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-5#|-#3-#|-#-.-#|2#-*-#|#2-*2#|#2-@2#|2#-$-#|-#3-#|-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban82
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-3#|#-.3-2#|2#*#$2-#|#-.#-$-#|#-@2#-2#|#5-#|7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban83
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'6#|#4-2#|#-$-$-2#|2#-2$2-#|-#-#3-#|-#-2#-2#|-#2-.-.#|-#-@.-.#|-#2-4#|-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban84
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#2-3.-#|#2-3#-2#|#2-#-$2-#|2#-#@$2-#|-#-#-$2-#|-#-3#-5#|-#9-#|-#3-3#3-#|-5#-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban85
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'7-4#|-7#2-#|-#-$6-#|-#3-$-$2-#|-#-8#|2#-#-.2-#|#2-#-#2-#|#2-@-.-2#|2#-#-#-#|-#3-.-#|-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban86
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'4-4#|2-3#2-2#|-2#-$3-#|2#-$2-#-#|#-@#2$2-#|#-2.2-3#|#-2.3#|5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban87
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|6#2-#|#7-#|#2-3.-.#|2#$6#|#-$2-#|#3-$3#|2#2-$2-#|-2#-@2-#|2-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban88
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5-4#|-#-3#2-#|-#-#4-#|-#-#2-#-#|-#-#$-#.#|-#-#2-#-#-#|-#-#$-#.#-#|3-#2-#-#-#|4#$-#.#-#|#-@5-#-#|#3-#2-2#-#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban89
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9##|#3-2#3-#|#-$2-$@#-#|4#-#-$-#|3-#.#2-2#|-#-#.#-$#|-#-#.3-#|-#-#.3-#|3-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban9
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#.2-2#|#@2$-#|2#3-#|-2#2-#|2-2#.#|3-3#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban90
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-8#|-#2-@3-#|-#-$2-$-#|3#-2#-3#|#2-$2.$2-#|#3-2.3-#|9##'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban91
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#2#|#4-.2#2-#|#-2$@2.2$-#|#3-2#.3-#|9#2#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban92
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-4#|2-#2-#4-5#|2-#2-#4-#3-#|2-#2-6#.#-#|4#2-$4-.2-#|#3-2$#-3#.#-#|#3-#3-#-#3-#|9#-#@-2#|9--#2-#|9--4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban93
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'-9#|2#3-#3-2#|#4-#4-#|#2-$-#-$2-#|#3-*.*3-#|4#.@.4#|#3-*.*3-#|#2-$-#-$2-#|#4-#4-#|2#3-#3-2#|-9#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban94
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9#|#-@-#3-#|#-$-$3-#|2#$3#-2#|#2-3.2-#|#3-#3-#|6#2-#|5-4#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban95
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'8#|#@5-#|#-.2$.-#|#-$2.$-#|#-$2.$-#|#-.2$.-#|#6-#|8#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban96
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'2-6#|2-#4-#|2-#4-#|5#2-#|#3-#.5#|#3-$@$3-#|5#.#3-#|3-2#-2#-2#|3-#3-$.#|3-#3-3#|3-5#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban97
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'3-4#|3-#2-8#|4#-$-$5.#|#3-$3-6#|#@3#-3#|#2-$2-#|#-$-#-#|2#-#2-#|-#4-#|-6#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban98
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'5#|#3-2#-4#|#2-$-3#-.#|#-$3-$2-.#|2#-$5#.#-4#|#-$2-#-#-.3#2-#|#4-#-#-.#2-@-#|3#2-#-#7-#|2-4#-2#5-2#|8-7#'! !

!SokoGame class methodsFor: 'levels-microban' stamp: 'mt 7/20/2007 21:22'!
microban99
	"Microban --- Copyright: David W Skinner --- E-Mail: sasquatch@bentonrea.com --- Web Site: http://users.bentonrea.com/~sasquatch/sokoban/"
	^'9-6-5#|9-6-#3-#|7#2-7#-#-#|#5-#2-#2-#6-#|#2-@2-4#2-#5-4#|#2-#4-4.2#-4#2-#|#4-5#-2#-2$-$-$-#|6#3-#9-2-#|9-#2-9##|9-4#'! !

!SokoGame class methodsFor: 'converting' stamp: 'mt 7/17/2007 16:52'!
offsetFrom: aDirection
	"Creates a move vector from a direction."
	
	aDirection = #left  ifTrue: [ ^-1@0 ].
	aDirection = #right ifTrue: [ ^1@0 ].
	aDirection = #up    ifTrue: [ ^0@-1 ].
	aDirection = #down  ifTrue: [ ^0@1 ].
! !

!SokoGame class methodsFor: 'converting' stamp: 'mt 7/17/2007 16:49'!
oppositeDirectionOf: aDirection
	"Maps a given direction to its opposite."
	
	aDirection = #up    ifTrue: [^#down].
	aDirection = #down  ifTrue: [^#up].
	aDirection = #left  ifTrue: [^#right].
	aDirection = #right ifTrue: [^#left].! !

!SokoGame class methodsFor: 'constants' stamp: 'mt 11/30/2007 15:02'!
animationWaitTime
	^5.! !

!SokoGame class methodsFor: 'constants' stamp: 'mt 7/17/2007 16:48'!
resourcePath
	"returns the path to all graphics"
	^'resource' asURI.! !

!SokoGame class methodsFor: 'constants' stamp: 'mt 11/30/2007 15:01'!
stepRange
	^5.! !

!SokoGame class methodsFor: 'constants' stamp: 'mt 11/30/2007 15:02'!
winAnimationWaitTime
	^20.! !


!SokoLevel methodsFor: 'accessing' stamp: 'mig 5/31/2007 19:14'!
boxes
	^boxes
	! !

!SokoLevel methodsFor: 'accessing' stamp: 'mig 5/31/2007 19:13'!
fields
	^fields! !

!SokoLevel methodsFor: 'accessing' stamp: 'mig 7/18/2007 00:05'!
mapsize
	^mapsize! !

!SokoLevel methodsFor: 'accessing' stamp: 'mig 5/31/2007 19:14'!
players
	^players
	! !

!SokoLevel methodsFor: 'accessing' stamp: 'mig 7/2/2007 23:44'!
replay
	^replay
	! !

!SokoLevel methodsFor: 'private' stamp: 'mig 7/19/2007 22:16'!
boxes: anOrderedCollection
	boxes := anOrderedCollection! !

!SokoLevel methodsFor: 'private' stamp: 'mig 7/19/2007 22:16'!
fields: anOrderedCollection
	fields := anOrderedCollection ! !

!SokoLevel methodsFor: 'private' stamp: 'mig 7/19/2007 22:16'!
mapsize: aPoint
	mapsize := aPoint ! !

!SokoLevel methodsFor: 'private' stamp: 'mig 7/20/2007 11:36'!
parseMap: aString
	"parses the classic sokoban, with support for rle-encoded levels"
	
	| currentRow maxWidth fieldtypes|
	
	self players: OrderedCollection new.
	self boxes: OrderedCollection new.
	self fields: OrderedCollection new.
	
	fieldtypes := Dictionary new.
	fieldtypes 
		at: $+ put: {SokoTarget};
		at: $* put: {SokoTarget};
		at: $. put: {SokoTarget};
		at: $# put: {SokoWall};
		at: $^ put: {SokoOneWay. #up};
		at: $v put: {SokoOneWay. #down};
		at: $< put: {SokoOneWay. #left};
		at: $> put: {SokoOneWay. #right}.
	
	maxWidth := 0.
		
	currentRow := 1.
	aString linesDo: [:line || currentCol currentFields |
			currentCol := 1.
			currentFields := OrderedCollection new.
			
			line do: [:character |
				"check for boxes and players first"
				(#($@ $+) includes: character) ifTrue: [
					self players add: (currentCol @ currentRow).
				].
				(#($$ $*) includes: character) ifTrue: [
					self boxes add: (currentCol @ currentRow).
				].
				
				"select the corresponding field class"				
				currentFields add: (fieldtypes at: character ifAbsent: {SokoWay}).

				currentCol := currentCol + 1.
			].
			
			"add current to map if not empty"
			currentFields ifNotEmpty: [
				self fields add: currentFields.
				currentRow := currentRow + 1.
			].
		
			maxWidth := maxWidth max: currentFields size.	
		].
	
	"adjust width of all rows"
	self fields do: [:row |
		[row size < maxWidth] whileTrue: [row add: {SokoWay}]
	].

	self mapsize: maxWidth @ (currentRow-1).
	
	^self.
! !

!SokoLevel methodsFor: 'private' stamp: 'mig 7/19/2007 22:16'!
players: anOrderedCollection
	players := anOrderedCollection! !

!SokoLevel methodsFor: 'private' stamp: 'mig 7/2/2007 23:44'!
replay: aString
	replay := aString
	! !


!SokoLevel class methodsFor: 'private' stamp: 'mig 7/18/2007 13:55'!
decodeRLE: aString
	"decodes RLE-encoded levels as used in Sokoban XSB-enhanced format"
	
	| stream decoded |
	
	decoded := aString species new.
	stream := aString readStream.
	
	[stream atEnd] whileFalse: [
		| symbol |
		symbol := stream next.
		symbol isDigit 
			ifFalse: [
				decoded := decoded, symbol asString.
			]
			ifTrue: [
				| count |
				count := symbol digitValue.
				symbol := stream next.
				count timesRepeat: [ decoded := decoded, symbol asString ].
			].
	].
	
	decoded := decoded copyReplaceAll: '|' with: String cr.
	^ decoded.
! !

!SokoLevel class methodsFor: 'private' stamp: 'rkrk 11/17/2007 21:30'!
prepareText: aString
	"correct line endings and strip comment lines"
	
	| result |
	
	result := aString species new.
	
	aString replaceAll: Character lf with: Character cr.
	aString linesDo: 	[ :line |
		(';*' match: line) ifFalse: [
			result := result, line, String cr.
		].
	].

	^result.
	! !

!SokoLevel class methodsFor: 'instance creation' stamp: 'mig 7/18/2007 13:58'!
fromClassicFormat: aString
	"parses classic sokoban levels, with support for rle-encoded levels"
		
	^self new parseMap: (self decodeRLE: (self prepareText: aString)).
! !

!SokoLevel class methodsFor: 'instance creation' stamp: 'mig 7/20/2007 16:24'!
fromSWAFormat: aString
	"parses swa formatted levels"
	
	| result prepared parameterpart mappart |
	
	prepared := self prepareText: aString.
	
	parameterpart := prepared copyUpTo: $!!.
	mappart := prepared copyAfter: $!!.
	
	result := self new parseMap: (self decodeRLE: mappart).
	
	parameterpart linesDo: [:line | | params |
		params := line subStrings: ':'.
		(params first = 'player') ifTrue: [result players add: (params second asInteger) @ (params third asInteger)].
		(params first = 'box') ifTrue: [result boxes add: (params second asInteger) @ (params third asInteger)].
		(params first = 'replay') ifTrue: [
			| replay |
			replay := OrderedCollection new.
			params second do: [:character |
				(character asLowercase = $u) ifTrue: [ replay add: #up ].
				(character asLowercase = $d) ifTrue: [ replay add: #down ].
				(character asLowercase = $l) ifTrue: [ replay add: #left ].
				(character asLowercase = $r) ifTrue: [ replay add: #right ].
			].
			result replay: replay.
		].
	].
	
	^ result.! !


!SokoPlayer methodsFor: 'accessing' stamp: 'mt 11/29/2007 22:59'!
canMoveTo: aDirection
	"Proves if the player can move into the given direction "
	
	| box |

	self playfield playerOne isMoving | self playfield playerTwo isMoving
		ifTrue: [^false].
	
	"Is there a valid field in front of me?"
	(self isValidFieldIn: aDirection for: #player) ifFalse: [^false].		
			
	"Is there another player in front of me?"
	(self isPlayerIn: aDirection) ifTrue: [^false].
				
	"Is there a box in front of me?"
	box := self playfield boxAt: ((SokoGame offsetFrom: aDirection) + self location).
	box ifNil: [^true].
	
	"Is there a valid field in front of the box?"
	(box isValidFieldIn: aDirection for: #box) ifFalse: [^false].
			
	"Is there a player in front of the box?"
	(box isPlayerIn: aDirection) ifTrue:[^false].
	
	"Is there a box in front of the box?"
	(box playfield boxAt: ((SokoGame offsetFrom: aDirection) + box location))
		ifNil: [^true].
		
	^false.
	! !

!SokoPlayer methodsFor: 'accessing' stamp: 'mt 11/30/2007 15:03'!
startWinAnimation
	"Lets the player perform a special animation in a 'win situation'."
	self
		animationWait: SokoGame winAnimationWaitTime;
		startAnimation: #jumping to: #down.! !

!SokoPlayer methodsFor: 'initialization' stamp: 'mt 11/29/2007 22:39'!
initializeWith: anAppearanceSymbol
	"use: obj initializeWith: #player"
	
	#(#walking #standing #pushing #pushstanding #jumping) do: [:aType |
		#(#up #down #left #right) do: [:aDirection |
			self addAnimationOf: aType to: aDirection for: anAppearanceSymbol
		]
	].

	self startAnimation: #standing to: #down.! !

!SokoPlayer methodsFor: 'moving' stamp: 'mt 11/30/2007 08:47'!
moveTo: aDirection animatedWith: anAnimationType withUndo: aBoolean
	"Concrete implementation of the superclass method"
	
	| animationDirection |

	animationDirection :=
		aBoolean
			ifTrue: [SokoGame oppositeDirectionOf: aDirection]
			ifFalse: [aDirection].

	self steps: (
		(aDirection = #left) | (aDirection = #right)
			ifTrue: [ SokoField tileWidth ]
			ifFalse: [ SokoField tileHeight ]
	).
	
	"memorize next location"
	self offset: (SokoGame offsetFrom: aDirection).	
	
	"update playfield overlapping"
	self playfield updateOverlappingFor: self in: aDirection.

	"start moving animation"
	self startAnimation: anAnimationType to: animationDirection.
	
	"tell step to start moving"
	self isMoving: true.! !

!SokoPlayer methodsFor: 'moving' stamp: 'mt 11/30/2007 14:57'!
step
	self isMoving
		ifTrue: [
			self steps = 0
				ifTrue: [
					|box1 box2| "have to check 2 boxes because of race conditions, box3 for undo"
					box1 := self playfield boxAt: self location + offset.
					box2 := self playfield boxAt: self location + offset + offset.
					
					self isMoving: false.
					self location: self location + offset.

					"stop the player animation"
					
					(box1 = nil) & (box2 = nil)
						ifFalse: [ self startAnimation: #pushstanding to: self direction ]
						ifTrue:  [ self startAnimation: #standing to: self direction ].
					
					self playfield game handleLevelDone.
				]
		].
		super step.! !


!SokoPlayfield methodsFor: 'testing' stamp: 'mt 7/2/2007 20:07'!
allBoxesOnTarget
	"Checks whether all boxes are on a target field so a level would be done."
	
	^self boxes allSatisfy: [:box|
		box isOnTarget].! !

!SokoPlayfield methodsFor: 'accessing' stamp: 'mt 7/2/2007 20:04'!
boxAt: aPosition
	"Try to return a SokoBox object found on the specified position. Returns nil on failure."
	
	self boxes do: [:box|
		box location = aPosition
			ifTrue: [^box]
	].

	^nil.! !

!SokoPlayfield methodsFor: 'accessing' stamp: 'mt 7/2/2007 20:07'!
fieldAt: aPosition
	"Returns a SokoField object found on the specified position.
	The y value represents the rowIndex and the x value the columnIndex of the internal SokoFields collection"
	
	^(self fields at: aPosition y) at: aPosition x.! !

!SokoPlayfield methodsFor: 'accessing' stamp: 'mt 6/24/2007 10:35'!
game
	^game.! !

!SokoPlayfield methodsFor: 'accessing' stamp: 'mt 7/14/2007 20:23'!
playerAt: aPoint
	"Try to return a SokoPlayer object found on the specified position. Returns nil on failure."
	
	self players do: [:player|
		player location = aPoint
			ifTrue: [^player]
	].

	^nil.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:43'!
boxes
	"Returns a collection of box objects for private usage."
	^boxes.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:45'!
boxes: aCollection
	^boxes := aCollection.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mig 7/11/2007 23:01'!
createBoxes: someBoxPositions
	"Create new boxes for the playfield."
	
	self boxes: OrderedCollection new.
	someBoxPositions do: [:position |
		(self boxes add: (self game cloneFrom: {SokoBox}))
			playfield: self;
			location: (position x @ position y).
		
		"add new box as submorph to playfield"
		self addMorph: (self boxes last).
	].
! !

!SokoPlayfield methodsFor: 'private' stamp: 'mig 7/11/2007 14:53'!
createFields: someFields
	"Create new fields for the playfield."
	
	self fields: OrderedCollection new.
	someFields do: [:row |
		| instanceRow |
		instanceRow := OrderedCollection new.
		row do: [:fieldtype |
			(instanceRow add: (self game cloneFrom: fieldtype))
				playfield: self.
				
			"add new field as submorph to playfield"
			self addMorph: (instanceRow last)
		].
		self fields add: instanceRow
	].
! !

!SokoPlayfield methodsFor: 'private' stamp: 'mig 7/11/2007 23:01'!
createPlayers: somePlayerPositions
	"Create new players for the playfield. --- TWO PLAYERS SUPPORTED!!"
	
	|appearance|

	appearance := #player.
	self players: OrderedCollection new.
	
	somePlayerPositions doWithIndex: [:position :index|
		
		index > 1 ifTrue: [appearance := #player2].
		
		(self players add: (self game cloneFrom: {SokoPlayer. appearance}))
			location: (position x @ position y);
			playfield: self.
			
		self addMorph: (self players at: index).
	].! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:42'!
fields
	"Returns a collection of field objects for private usage."
	^fields.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:46'!
fields: aTwoDimensionalCollection
	^fields := aTwoDimensionalCollection.! !

!SokoPlayfield methodsFor: 'private' stamp: 'amb 7/16/2007 11:35'!
getColumnsToUpdateFor: aSokoPlayer movingTo: aDirection
	"get columns which need to be updated. Used for updateOverlappingFor:in: only"
	| columnsToUpdate  |
	columnsToUpdate := OrderedCollection new.
	"column with player needs to be always updated"
	columnsToUpdate add: aSokoPlayer location x.
	"if player moves horizontally, more column indizes need to be updated"
	((SokoGame offsetFrom: aDirection) x == 0)
		ifFalse: [ |column|
			"player moves to first column, so it needs to be updated" 
			columnsToUpdate add: (aSokoPlayer location x + (SokoGame offsetFrom: aDirection) x).
			"if player pushes a box, the next column also needs to update. If it's a valid column id, then add it"
			column := (2 * (SokoGame offsetFrom: aDirection) x + aSokoPlayer location x).
			(column >= 1) & (column <= self fields first size)
				ifTrue: [columnsToUpdate add: column]].	
	^columnsToUpdate! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:42'!
players
	"Returns a collection of player objects for private usage."
	^players.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:45'!
players: aCollection
	^players := aCollection.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 20:12'!
resetLocationsTo: somePlayerLocations and: someBoxLocations
	"Used to restart a current level"
	
	self players doWithIndex: [:player :index|
		player 
			location: (somePlayerLocations at: index);
			startAnimation: #standing to: #down. 
	].
		
	self boxes doWithIndex: [:box :index|
		box location: (someBoxLocations at: index).
	].	
		
	self updateAllPositions.
	! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 20:00'!
updateAllPositions
	"Resets all playfield objects (players, boxes, fields) to their correct position"
	
	self
		updateFieldPositions;
		updateBoxPositions;
		updatePlayerPositions;
		
		"overlapping could have changed due to position reset"
		updateOverlapping.! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:58'!
updateBoxPositions
	"Update positions for SokoBoxes."
	
	self boxes do: [:box|
		box position:
		  (Point x: (box location x - 1) * SokoField tileWidth
		         y: (box location y - 1) * SokoField tileHeight + SokoField tileHeight - (box currentFrameSize y)) + self position.
		box changeImage.
	].! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:57'!
updateFieldPositions
	"Update position of SokoField objects: walls, ways, targets..."
	
	self fields doWithIndex: [:row :rowIndex|
		row doWithIndex: [:field :columnIndex|
			field position:
				(Point x: (columnIndex-1) * SokoField tileWidth
				       y: (rowIndex-1) * SokoField tileHeight + SokoField tileHeight - (field currentFrameSize y)) + self position.
			field changeImage.
		]
	].! !

!SokoPlayfield methodsFor: 'private' stamp: 'mt 7/2/2007 19:59'!
updatePlayerPositions
	"Update positions for SokoPlayers."
	
	self players do: [:player|
		player position:
		  (Point x: (player location x - 1) * SokoField tileWidth
		         y: (player location y - 1) * SokoField tileHeight  + SokoField tileHeight - (player currentFrameSize y)) + self position.
		player changeImage.
	].! !

!SokoPlayfield methodsFor: 'initialization' stamp: 'mt 6/23/2007 18:40'!
game: aSokoGame
	game := aSokoGame.! !

!SokoPlayfield methodsFor: 'creation' stamp: 'mt 7/2/2007 20:13'!
loadMapWith: someFields with: someBoxes with: somePlayers
	"creates all submorphs/instances (boxes, playes, fields) for the playfield"
	
	self 
		createFields: someFields;
		createBoxes: someBoxes;
		createPlayers: somePlayers;
		updateAllPositions.! !

!SokoPlayfield methodsFor: 'player access' stamp: 'mig 7/17/2007 23:33'!
playerOne
	^self players first.! !

!SokoPlayfield methodsFor: 'player access' stamp: 'mig 7/17/2007 23:34'!
playerTwo
	"Only return player two, if the level really has two-player-support - otherwise return player1 again."
	
	self players size > 1
		ifTrue: [^self players second]
		ifFalse: [^self playerOne]! !

!SokoPlayfield methodsFor: 'drawing' stamp: 'mt 7/2/2007 20:16'!
updateOverlapping
	"Update overlapping of each submorph from playfield (-> back to front)"
	
	self fields doWithIndex: [:row :depth|
		row do: [:field|
			field isWayField 
				ifFalse: [field comeToFront]
		].
	
		"SokoActors are standing on previously updated fields."
		(self boxes, self players) do: [:actor| 
			actor location y = depth
				ifTrue: [actor comeToFront]
		]
	].! !

!SokoPlayfield methodsFor: 'drawing' stamp: 'mig 7/20/2007 20:20'!
updateOverlappingFor: aSokoPlayer in: aDirection 
	"updates the overlapping for aSokoplayer moving in aDirection"
	
	| columnsToUpdate |
	columnsToUpdate := self getColumnsToUpdateFor: aSokoPlayer movingTo: aDirection.
	"update overlapping of each field (from back to front)"
	"1 is the depth of the last row standing. =)"  
	aSokoPlayer location y to: self fields size do: [:depth|
		"update static fields. Way fields are always in background. so they can be ignored"
		columnsToUpdate do: [:x| |field|
			field := (self fields at: depth) at: x.
			field isWayField ifFalse: [field comeToFront]].
		
		"actors (boxes and player) are standing on previously updated fields" 
		(self boxes, self players) do: [:actor|  
			(actor location y == depth) & (columnsToUpdate includes: actor location x)
      		ifTrue: [actor comeToFront]]]. 
! !


!SokoPlayfield class methodsFor: 'new-morph participation' stamp: 'mt 6/14/2007 18:00'!
includeInNewMorphMenu
	^false.! !


!SokoWall methodsFor: 'initialization' stamp: 'mig 6/13/2007 16:00'!
initialize

	super initialize.
	
	self addAnimationOf: #standing to: #up for: #wall.
	self startAnimation: #standing to: #up! !

!SokoWall methodsFor: 'directing' stamp: 'Tisch 6/10/2007 13:05'!
isMoveAllowedFrom: aDirection by: aSokoObject

	"Concrete implementation of the superclass method."
	
	^false.! !


!SokoWay methodsFor: 'initialization' stamp: 'mig 6/13/2007 16:08'!
initialize

	super initialize.
	
	self addAnimationOf: #standing to: #up for: #way.
	self startAnimation: #standing to: #up
	! !

!SokoWay methodsFor: 'directing' stamp: 'Tisch 6/12/2007 21:48'!
isMoveAllowedFrom: aDirection by: aSokoObject

	^true.! !

!SokoWay methodsFor: 'testing' stamp: 'amb 6/14/2007 15:24'!
isWayField
	^true! !


!SokoOneWay methodsFor: 'initialization' stamp: 'fe 7/10/2007 23:03'!
initializeWith: aDirection

	"This message completes initialization."
	self 
		restrictedDirection: aDirection;
		addAnimationOf: #standing to: aDirection for: #oneway;
		startAnimation: #standing to: aDirection.
		
		! !

!SokoOneWay methodsFor: 'directing' stamp: 'mig 7/18/2007 11:14'!
isMoveAllowedFrom: aDirection by: aSymbol

	"Move is only denied, when a box wants to enter from the restricted direction"
	
	^ (aSymbol = #box & (aDirection = self restrictedDirection)) not.
			 ! !

!SokoOneWay methodsFor: 'accessing' stamp: 'fe 7/10/2007 21:48'!
restrictedDirection
	"Answer the restricted direction"

	^ restrictedDirection! !

!SokoOneWay methodsFor: 'accessing' stamp: 'fe 7/10/2007 21:49'!
restrictedDirection: aDirection
	"Set the restricted direction"

	restrictedDirection := aDirection.! !


!SokoTarget methodsFor: 'initialization' stamp: 'mig 6/13/2007 18:52'!
initialize

	super initialize.
	
	self addAnimationOf: #standing to: #up for: #target.
	self startAnimation: #standing to: #up
	! !

!SokoTarget methodsFor: 'testing' stamp: 'Tisch 6/12/2007 21:51'!
isTargetField
	
	^true! !


!Stack methodsFor: 'accessing' stamp: 'dc 7/25/2005 10:04'!
size
	"How many objects in me ?"
	^ self linkedList size! !

!Stack methodsFor: 'accessing' stamp: 'sd 3/25/2006 15:05'!
top
	"Answer the first element of the stack without removing it."
	self notEmptyCheck.
	^ self linkedList first element! !

!Stack methodsFor: 'adding' stamp: 'dc 7/25/2005 10:22'!
push: anObject 
	"Adds a new object of any kind on top of the stack."
	self linkedList
		addFirst: (StackLink with: anObject).
	^ anObject.! !

!Stack methodsFor: 'initialize-release' stamp: 'dc 7/25/2005 11:39'!
initialize
	super initialize.
	linkedList := LinkedList new! !

!Stack methodsFor: 'removing' stamp: 'dc 7/24/2005 16:16'!
pop
	"Returns the first element and remove it from the stack."

	self notEmptyCheck.
	^self linkedList removeFirst element! !

!Stack methodsFor: 'testing' stamp: 'dc 7/25/2005 10:05'!
isEmpty
	^ self linkedList isEmpty! !

!Stack methodsFor: 'private' stamp: 'dc 7/25/2005 10:05'!
errorEmptyStack
	self error: 'this stack is empty'! !

!Stack methodsFor: 'private' stamp: 'dc 7/25/2005 10:20'!
linkedList
	"The stack is implemented with a LinkedList. Do NOT call this function, it  
	is for private use !!"
	^ linkedList! !

!Stack methodsFor: 'private' stamp: 'dc 7/25/2005 10:05'!
notEmptyCheck
	"Ensure the stack is not empty."
	self isEmpty
		ifTrue: [self errorEmptyStack]! !


!SokoCommandStack methodsFor: 'removing' stamp: 'mig 7/19/2007 23:20'!
clear
	self moves: 0.
	self pushes: 0.
	self redoStack initialize.
	^super initialize.
	! !

!SokoCommandStack methodsFor: 'removing' stamp: 'mt 7/20/2007 12:08'!
clearToReplayStack
	[self isEmpty]
		whileFalse: [self pop].
		
	self moves: 0.! !

!SokoCommandStack methodsFor: 'removing' stamp: 'mig 7/19/2007 23:20'!
pop
	self moves: self moves + 1. "penalty for undo"

	"find out if it's a push or only a move'"
	self top isPushCommand
		ifTrue: [self pushes: self pushes - 1].
		
	self redoStack push: self top.
		
	^super pop.! !

!SokoCommandStack methodsFor: 'initialize-release' stamp: 'mig 7/19/2007 23:21'!
initialize
	super initialize.
	self moves: 0.
	self pushes: 0.
	self redoStack: Stack new.! !

!SokoCommandStack methodsFor: 'accessing' stamp: 'amb 6/20/2007 12:13'!
moves
	^moves! !

!SokoCommandStack methodsFor: 'accessing' stamp: 'amb 6/20/2007 12:14'!
pushes
	^pushes! !

!SokoCommandStack methodsFor: 'private' stamp: 'mt 7/12/2007 14:32'!
moves: aNumber
	moves := aNumber.! !

!SokoCommandStack methodsFor: 'private' stamp: 'mig 7/19/2007 23:19'!
pushes: aNumber
	pushes := aNumber! !

!SokoCommandStack methodsFor: 'private' stamp: 'mig 7/20/2007 20:17'!
redoCommand
	"redo a previously undone command"
	
	self redoStack isEmpty
		ifFalse: [
			super push: self redoStack top.
			self redoStack pop.
			self top direction: (SokoGame oppositeDirectionOf: self top direction).
			
			self moves: self moves + 1. "penalty for using redo."
	
			self top isPushCommand
				ifTrue: [self pushes: self pushes + 1].			
			
			^self top
		].
	^nil.! !

!SokoCommandStack methodsFor: 'private' stamp: 'mig 7/19/2007 23:17'!
redoStack
	^ redoStack! !

!SokoCommandStack methodsFor: 'private' stamp: 'mig 7/19/2007 23:17'!
redoStack: anObject
	redoStack := anObject! !

!SokoCommandStack methodsFor: 'adding' stamp: 'mig 7/19/2007 23:21'!
push: aSokoCommand
	"player moves everytime"
	self moves: self moves + 1.
	
	"sokoActor pushes a box?"
	aSokoCommand isPushCommand
		ifTrue: [self pushes: self pushes + 1].
		
	"avoid inconsistent state"
	self redoStack initialize.
		
	^super push: aSokoCommand.! !


!StackLink methodsFor: 'accessing' stamp: 'dc 7/24/2005 15:34'!
element
	^element! !

!StackLink methodsFor: 'accessing' stamp: 'dc 7/25/2005 10:16'!
element: anObject 
	"Any kind of Object."
	element := anObject! !

!StackLink methodsFor: 'printing' stamp: 'dc 7/25/2005 10:15'!
printOn: aStream 
	aStream nextPutAll: self class printString;
		 nextPutAll: ' with: ';
		 nextPutAll: self element printString! !


!StackLink class methodsFor: 'instance creation' stamp: 'dc 7/25/2005 10:15'!
with: anObject 
	^ self new element: anObject! !

SokoPlayer removeSelector: #isMoving!
SokoPlayer removeSelector: #isMoving:!
SokoGame class removeSelector: #ImageStorage:!

!SokoGame class reorganize!
('storage' addGraphics:data: initializeResources loadGraphicWithName: matchingGraphics:)
('parts bin' descriptionForPartsBin imageStorage:)
('levels' levelSetWith:with: swaset1 swaset2 swaset3 swaset4 swaset5)
('levels-masmicroban' masmicroban1 masmicroban10 masmicroban100 masmicroban101 masmicroban102 masmicroban103 masmicroban104 masmicroban105 masmicroban106 masmicroban107 masmicroban108 masmicroban109 masmicroban11 masmicroban110 masmicroban111 masmicroban112 masmicroban113 masmicroban114 masmicroban115 masmicroban116 masmicroban117 masmicroban118 masmicroban119 masmicroban12 masmicroban120 masmicroban121 masmicroban122 masmicroban123 masmicroban124 masmicroban125 masmicroban126 masmicroban127 masmicroban128 masmicroban129 masmicroban13 masmicroban14 masmicroban15 masmicroban16 masmicroban17 masmicroban18 masmicroban19 masmicroban2 masmicroban20 masmicroban21 masmicroban22 masmicroban23 masmicroban24 masmicroban25 masmicroban26 masmicroban27 masmicroban28 masmicroban29 masmicroban3 masmicroban30 masmicroban31 masmicroban32 masmicroban33 masmicroban34 masmicroban35 masmicroban36 masmicroban37 masmicroban38 masmicroban39 masmicroban4 masmicroban40 masmicroban41 masmicroban42 masmicroban43 masmicroban44 masmicroban45 masmicroban46 masmicroban47 masmicroban48 masmicroban49 masmicroban5 masmicroban50 masmicroban51 masmicroban52 masmicroban53 masmicroban54 masmicroban55 masmicroban56 masmicroban57 masmicroban58 masmicroban59 masmicroban6 masmicroban60 masmicroban61 masmicroban62 masmicroban63 masmicroban64 masmicroban65 masmicroban66 masmicroban67 masmicroban68 masmicroban69 masmicroban7 masmicroban70 masmicroban71 masmicroban72 masmicroban73 masmicroban74 masmicroban75 masmicroban76 masmicroban77 masmicroban78 masmicroban79 masmicroban8 masmicroban80 masmicroban81 masmicroban82 masmicroban83 masmicroban84 masmicroban85 masmicroban86 masmicroban87 masmicroban88 masmicroban89 masmicroban9 masmicroban90 masmicroban91 masmicroban92 masmicroban93 masmicroban94 masmicroban95 masmicroban96 masmicroban97 masmicroban98 masmicroban99)
('levels-microban' microban1 microban10 microban100 microban101 microban102 microban103 microban104 microban105 microban106 microban107 microban108 microban109 microban11 microban110 microban111 microban112 microban113 microban114 microban115 microban116 microban117 microban118 microban119 microban12 microban120 microban121 microban122 microban123 microban124 microban125 microban126 microban127 microban128 microban129 microban13 microban130 microban131 microban132 microban133 microban134 microban135 microban136 microban137 microban138 microban139 microban14 microban140 microban141 microban142 microban143 microban144 microban145 microban146 microban147 microban148 microban149 microban15 microban150 microban151 microban152 microban153 microban16 microban17 microban18 microban19 microban2 microban20 microban21 microban22 microban23 microban24 microban25 microban26 microban27 microban28 microban29 microban3 microban30 microban31 microban32 microban33 microban34 microban35 microban36 microban37 microban38 microban39 microban4 microban40 microban41 microban42 microban43 microban44 microban45 microban46 microban47 microban48 microban49 microban5 microban50 microban51 microban52 microban53 microban54 microban55 microban56 microban57 microban58 microban59 microban6 microban60 microban61 microban62 microban63 microban64 microban65 microban66 microban67 microban68 microban69 microban7 microban70 microban71 microban72 microban73 microban74 microban75 microban76 microban77 microban78 microban79 microban8 microban80 microban81 microban82 microban83 microban84 microban85 microban86 microban87 microban88 microban89 microban9 microban90 microban91 microban92 microban93 microban94 microban95 microban96 microban97 microban98 microban99)
('converting' offsetFrom: oppositeDirectionOf:)
('constants' animationWaitTime resourcePath stepRange winAnimationWaitTime)
('initialization')
!

SokoActor removeSelector: #direction!
SokoActor removeSelector: #direction:!
SokoActor removeSelector: #isOnTarget!
SokoActor removeSelector: #makeMoveTo:!
SokoActor removeSelector: #moveBackwards!
SokoActor removeSelector: #moveBackwards:!
SokoActor removeSelector: #nextLocation!
SokoActor removeSelector: #nextLocation:!
SokoActor removeSelector: #sleep!
SokoActor removeSelector: #sleep:!

!SokoActor reorganize!
('moving' isPlayerIn: isValidFieldIn:for: step)
('accessing' isMoving isMoving: location location: moveTo:animatedWith:withUndo: offset offset: steps steps:)
('initialization' initialize)
!

